﻿local M = unpack(select(2,...))

-- Style Frame
M.style = function (myframe,nobg,off,blend)
	off = off or 3
	
	if nobg ~= true then
		if not myframe.bg then
			local bg = myframe:CreateTexture(nil,"BORDER")
			bg:SetPoint("TOPLEFT",off+1,-off-1)
			bg:SetPoint("BOTTOMRIGHT",-off-1,off+1)
			bg:SetTexture(1,1,1,1)
			bg:SetGradientAlpha("VERTICAL",unpack(M["media"].gradient))
			bg:SetBlendMode(blend or "ADD")
			myframe.bg = bg
		end
	end
	
	local left = myframe:CreateTexture(nil,"OVERLAY")
	left:SetTexture(unpack(M["media"].border))
	left:SetPoint("TOPLEFT",off,-off)
	left:SetPoint("BOTTOMLEFT",off,off)
	left:SetWidth(1)
	myframe.left = left
	
	local right = myframe:CreateTexture(nil,"OVERLAY")
	right:SetTexture(unpack(M["media"].border))
	right:SetPoint("TOPRIGHT",-off,-off)
	right:SetPoint("BOTTOMRIGHT",-off,off)
	right:SetWidth(1)
	myframe.right = right
	
	local bottom = myframe:CreateTexture(nil,"OVERLAY")
	bottom:SetTexture(unpack(M["media"].border))
	bottom:SetPoint("BOTTOMLEFT",off,off)
	bottom:SetPoint("BOTTOMRIGHT",-off,off)
	bottom:SetHeight(1)
	myframe.bottom = bottom
	
	local top = myframe:CreateTexture(nil,"OVERLAY")
	top:SetTexture(unpack(M["media"].border))
	top:SetPoint("TOPLEFT",off,-off)
	top:SetPoint("TOPRIGHT",-off,off)
	top:SetHeight(1)
	myframe.top = top
end

-- Set Frame Backdrop (st one)
M.setbackdrop = function(self)
	self:SetBackdrop(M["bg"])
	self:SetBackdropBorderColor(unpack(M["media"].shadow))
	self:SetBackdropColor(unpack(M["media"].color))
end

-- Change Template
M.ChangeTemplate = function(self) M.setbackdrop(self); M.style(self); end

-- CreateFrame
M.frame = function(parent,level,strata,nobg,nols,off,tag)
	local myframe = CreateFrame("Frame",tag,parent)
	if nols ~= true then
		myframe:SetFrameLevel(level or 2)
		myframe:SetFrameStrata(strata or "BACKGROUND")
	end
	M.setbackdrop(myframe)
	M.style(myframe,nobg,off)
	return myframe
end

-- To change frames color
M.backcolor = function(self,r,g,b,alp,stop)
	self.top:SetTexture(r,g,b)
	self.bottom:SetTexture(r,g,b)
	self.right:SetTexture(r,g,b)
	self.left:SetTexture(r,g,b)
	if stop then return end
	if not alp then
		self:SetBackdropBorderColor(unpack(M["media"].shadow))
	else
		self:SetBackdropBorderColor(r,g,b,alp or 1)
	end
end