﻿local names = Hissy[2]['latency']
local M = Hissy[1]
local select = select
local C = select(2,...)
local int, Memory, Total, Mem, MEMORY_TEXT = 0, {}
local pg, pg_l = 0,0
local GetAddOnInfo = GetAddOnInfo
local GetAddOnMemoryUsage = GetAddOnMemoryUsage
local UpdateAddOnMemoryUsage = UpdateAddOnMemoryUsage
local collectgarbage = collectgarbage
local sort = table.sort
local IsAddOnLoaded = IsAddOnLoaded
local floor = math.floor
local format = string.format
local GetFramerate = GetFramerate
local GetNetStats = GetNetStats
local GetAvailableBandwidth = GetAvailableBandwidth
local GetDownloadedPercentage = GetDownloadedPercentage

local function formatMem(memory, color)		
	local mult = 10^1
	if memory > 999 then
		local mem = floor((memory/1024) * mult + 0.5) / mult
		if mem % 1 == 0 then
			return mem..".0"..names.memorymfrom
		else
			return mem..names.memorymfrom
		end
	else
		local mem = floor(memory * mult + 0.5) / mult
			if mem % 1 == 0 then
				return mem..".0"..names.memorykfrom
			else
				return mem..names.memorykfrom
			end
	end
end
	
local function RefreshMem(self)
	Memory = {}
	Total = 0
	collectgarbage("collect")
	UpdateAddOnMemoryUsage()
	for i = 1, GetNumAddOns() do
		Mem = GetAddOnMemoryUsage(i)
		Memory[i] = { select(2, GetAddOnInfo(i)), Mem, IsAddOnLoaded(i) }
		Total = Total + Mem
	end
	MEMORY_TEXT = formatMem(Total, true)
	sort(Memory, function(a, b)
		if a and b then
			return a[2] > b[2]
		end
	end)
end

local set_color_r_g = function(p)
	local r,g
	local a = 1 - p/300
		if a >= .7 then
			r = 0; g = 1
		elseif a >= .3 then
			r = 1; g  = 1
		else 
			r = 1; g = 0
		end
	return r,g,0
end

local formtooltip = function(self)
	GameTooltip:ClearLines()
	GameTooltip:AddDoubleLine(names._local..names.ping,pg_l..names.pingval,1,1,1,set_color_r_g(pg_l))
	GameTooltip:AddDoubleLine(names.global..names.ping,pg..names.pingval,1,1,1,set_color_r_g(pg))
	GameTooltip:AddDoubleLine (names.framerate,floor(GetFramerate())..names.framerateval,1,1,1,1,1,1)
	GameTooltip:AddDoubleLine (names.memorytotal,MEMORY_TEXT,1,1,1,1,1,1)
	local bandwidth = GetAvailableBandwidth()
	if bandwidth ~= 0 then
		GameTooltip:AddDoubleLine(names.band,(floor(bandwidth*100)/100)..names.mps,1,1,1,1,1,1)
		GameTooltip:AddDoubleLine(names.done,floor((100*GetDownloadedPercentage())+.5).." %",1,1,1,1,1,1)
	end
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine (names.memorytool,1,1,1)
	GameTooltip:AddLine(" ")
	for i = 1, #Memory do
		if Memory[i][3] then 
			local red = Memory[i][2]/Total*2
			local green = 1 - red
			GameTooltip:AddDoubleLine(Memory[i][1], formatMem(Memory[i][2], false), 1, 1, 1, red, green+1, 0)						
		end
	end
	GameTooltip:Show()
end

local C = select(2,...)

local ping = C.frame("Latency",300,false)
ping.tx:SetText("Latency")
	
local nullf = M.null	
local rofl = M.null

local mx = math.max
ping:SetScript("OnUpdate", function(self,t)
	int = int - t
	rofl(self,t)
	if int >0 then return end
	int = 30
	pg = select(4, GetNetStats())
	pg_l = select(3, GetNetStats())
	self:SetVal(mx(pg,pg_l))
end)

local h,k = 0,0
local updatem = function(self,t)
	h = h - t
	k = k - t
	if h > 0 then return end
	h = .5
	formtooltip(self)
	if k > 0 then return end
	k = 10
	RefreshMem(self)
end

ping:SetScript("OnEnter", function(self)
	RefreshMem(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:ClearAllPoints()
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 0, -2)
	rofl = updatem
	rofl(self,.5)
end)
	
ping:SetScript("OnMouseDown", function(self,bt)
	if bt == "" then
		-- next time
	else
		collectgarbage("collect")
	end
end)
	
ping:SetScript("OnLeave", function()
	rofl = nullf
	GameTooltip:Hide()
end)