﻿local C = select(2,...)
local M = Hissy[1]
local Class = M.Class
local GetSpellBonusHealing = GetSpellBonusHealing
local GetSpellBonusDamage = GetSpellBonusDamage
local UnitRangedAttackPower = UnitRangedAttackPower
local UnitAttackPower = UnitAttackPower
local player = "player"
local hunter = "HUNTER"
local format = format
local abs = abs
local GetCombatRating = GetCombatRating

-- Dis is Power
local Power = C.frame("Power",nil,true)

local get_power = M.null
	
local get_spd = function()
	local h = GetSpellBonusHealing()
	local s = GetSpellBonusDamage(7)
	if h > s then
		return h,"Sph"
	else
		return s,"Spd"
	end
end

local get_hunter = function()
	local Rbase, RposBuff, RnegBuff = UnitRangedAttackPower(player)
	return Rbase + RposBuff + RnegBuff, "Ap"
end

local get_other = function()
	local base, posBuff, negBuff = UnitAttackPower(player)
	return base + posBuff + negBuff, "Ap"
end

-- checking
M.addafter(function() 
	local a = get_other()
	local b = get_spd()
	if a > b and Class ~= hunter then
		get_power = get_other
	elseif Class == hunter then
		get_power = get_hunter
	else
		get_power = get_spd
	end
end)

local pint = 0
local function Power_Update(self,t)
	pint = pint - t
	if pint > 0 then return end; pint = 0;
	local a,b = get_power()
	self.rt:SetText(b)
	self.lt:SetText(a)
end

Power:SetScript("OnUpdate", Power_Update)
----------------------------------------


-- Dis is Hit Rating
local Hit = C.frame("Hit",nil,true)
Hit.rt:SetText("Hit")

local get_hit = M.null
local GetCombatRatingBonus = GetCombatRatingBonus

M.addafter(function()
	local a = get_other()
	local b = get_spd()
	if a > b and Class ~= hunter then
		get_hit = function() return format("%.2f", GetCombatRatingBonus(6)) end
	elseif Class == hunter then
		get_hit = function() return format("%.2f", GetCombatRatingBonus(7)) end
	else
		get_hit = function() return format("%.2f", GetCombatRatingBonus(8)) end
	end
end)

local hint = 0
local Hit_Update = function(self,t)
	hint = hint - t
	if hint > 0 then return end; hint = 0;
	self.lt:SetText(get_hit())
end

Hit:SetScript("OnUpdate", Hit_Update)
------------------------------------


-- Dis is Mastery
local Mastery = C.frame("Mastery",nil,true)
Mastery.rt:SetText("Mas")

local mint = 0
local Mastery_Update = function(self,t)
	mint = mint - t
	if mint > 0 then return end; mint = 0;
	self.lt:SetText(GetCombatRating(26))
end

Mastery:SetScript("OnUpdate",Mastery_Update)
--------------------------------------------


-- Dis is Haste
local Haste = C.frame("Haste",nil,true)
Haste.rt:SetText("Haste")

local get_haste = M.null

M.addafter(function()
	local b = GetCombatRating(20)
	local a = GetCombatRating(18)
	if a > b and Class ~= hunter then
		get_haste = function() return GetCombatRating(18) end
	elseif Class == hunter then
		get_haste = function() return GetCombatRating(19) end
	else
		get_haste = function() return GetCombatRating(20) end
	end
end)

local uint = 0
local Haste_Update = function(self,t)
	uint = uint - t
	if uint > 0 then return end; uint = 0;
	self.lt:SetText(get_haste())
end

Haste:SetScript("OnUpdate",Haste_Update)
----------------------------------------


-- Dis is Crit Rating
local Crit = C.frame("Crit",nil,true)
Crit.rt:SetText("Crit")
local GetSpellCritChance = GetSpellCritChance
local GetCritChance = GetCritChance
local GetRangedCritChance = GetRangedCritChance
local GetSpellCritChance = GetSpellCritChance

local get_Crit = M.null

M.addafter(function()
	local b = GetSpellCritChance(1)
	local a = GetCritChance()
	if a > b and Class ~= hunter then
		get_Crit = function() return format("%.2f", GetCritChance()) end
	elseif Class == hunter then
		get_Crit = function() return format("%.2f", GetRangedCritChance()) end
	else
		get_Crit = function() return format("%.2f",GetSpellCritChance(1)) end
	end
end)

local cint = 0
local Crit_Update = function(self,t)
	cint = cint - t
	if cint > 0 then return end; cint = 0;
	self.lt:SetText(get_Crit())
end

Crit:SetScript("OnUpdate", Crit_Update)
----------------------------------------


-- Dis is Armor
local Armor = C.frame("Armor",nil,true)
Armor.rt:SetText("Arm")
Armor:RegisterEvent("UNIT_INVENTORY_CHANGED")
Armor:RegisterEvent("UNIT_AURA")
Armor:RegisterEvent("PLAYER_ENTERING_WORLD")

local correct = function(attackerLevel,armor)
	local levelModifier = attackerLevel;
	if ( levelModifier > 59 ) then
	levelModifier = levelModifier + (4.5 * (levelModifier-59));
	end
	local temp = 0.1*armor/(8.5*levelModifier + 40);
	temp = temp/(1+temp);

	if ( temp > 0.75 ) then
		return 75;
	end

	if ( temp < 0 ) then
		return 0;
	end

	return temp*100;
end

local UnitArmor,UnitLevel = UnitArmor,UnitLevel

local Armor_Update = function(self)
	local _,arm = UnitArmor("player")
	self.lt:SetText(arm)
end

local Armor_Enter = function(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:ClearAllPoints()
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 0, -2)
	GameTooltip:ClearLines()
	local lvl = UnitLevel("player") + 3
	local _,arm = UnitArmor("player")
	for i = 1,7 do
		GameTooltip:AddDoubleLine(lvl.." lvl",format("%.2f",correct(lvl,arm)).."%",1,1,1,1-i/7,i/7,.3)
		lvl = lvl - 1
	end
	GameTooltip:Show()
end

Armor:SetScript("OnEvent",Armor_Update)
Armor:SetScript("OnEnter",Armor_Enter)
Armor:SetScript("OnLeave",function() GameTooltip:Hide() end)
--------------------------------------------


-- Dis is Avoidance
local Avoidance = C.frame("Avoidance",nil,true)
Avoidance.rt:SetText("Avd")
Avoidance:RegisterEvent("UNIT_AURA")
Avoidance:RegisterEvent("UNIT_INVENTORY_CHANGED")
Avoidance:RegisterEvent("PLAYER_TARGET_CHANGED")
Avoidance:RegisterEvent("PLAYER_ENTERING_WORLD")

local targetlv
local playerlv
local dodge
local parry
local block
local MissChance
local GetDodgeChance,GetParryChance = GetDodgeChance,GetParryChance
local GetBlockChance,GetCombatRating = GetBlockChance,GetCombatRating 

local function AV_Update(self)
	local format = string.format
	targetlv, playerlv = UnitLevel("target"), UnitLevel("player")
	local basemisschance
	local leveldifference
	local avoidance

	if targetlv == -1 then
		basemisschance = (5 - (3*.2))  --Boss Value
		leveldifference = 3
	elseif targetlv > playerlv then
		basemisschance = (5 - ((targetlv - playerlv)*.2)) --Mobs above player level
		leveldifference = (targetlv - playerlv)
	elseif targetlv < playerlv and targetlv > 0 then
		basemisschance = (5 + ((playerlv - targetlv)*.2)) --Mobs below player level
		leveldifference = (targetlv - playerlv)
	else
		basemisschance = 5 --Sets miss chance of attacker level if no target exists, lv80=5, 81=4.2, 82=3.4, 83=2.6
		leveldifference = 0
	end

	if leveldifference >= 0 then
		dodge = (GetDodgeChance()-leveldifference*.2)
		parry = (GetParryChance()-leveldifference*.2)
		block = (GetBlockChance()-leveldifference*.2)
		MissChance = (basemisschance + 1/(0.0625 + 0.956/(GetCombatRating(CR_DEFENSE_SKILL)/4.91850*0.04)))
		avoidance = (dodge+parry+block+MissChance)
		self.lt:SetText(format("%.2f", avoidance))
	else
		dodge = (GetDodgeChance()+abs(leveldifference*.2))
		parry = (GetParryChance()+abs(leveldifference*.2))
		block = (GetBlockChance()+abs(leveldifference*.2))
		MissChance = (basemisschance + 1/(0.0625 + 0.956/(GetCombatRating(CR_DEFENSE_SKILL)/4.91850*0.04)))
		avoidance = (dodge+parry+block+MissChance)
		self.lt:SetText(format("%.2f", avoidance))
	end
end
	
local names = Hissy[2]['avoid']
Avoidance:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:ClearAllPoints()
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 0, -2)
	GameTooltip:ClearLines()
	if targetlv > 1 then
		GameTooltip:AddDoubleLine(names["avoid"],"("..targetlv.." lvl)")
	elseif targetlv == -1 then
		GameTooltip:AddDoubleLine(names["avoid"],"(boss)")
	else
		GameTooltip:AddDoubleLine(names["avoid"],"("..targetlv.." lvl)")
	end
	GameTooltip:AddDoubleLine(names["miss"],format("%.2f",MissChance) .. "%",1,1,1, 1,1,1)
	GameTooltip:AddDoubleLine(names["dodge"],format("%.2f",dodge) .. "%",1,1,1, 1,1,1)
	GameTooltip:AddDoubleLine(names["parry"],format("%.2f",parry) .. "%",1,1,1, 1,1,1)
	GameTooltip:AddDoubleLine(names["block"],format("%.2f",block) .. "%",1,1,1, 1,1,1)
	GameTooltip:Show()
end)
Avoidance:SetScript("OnLeave", function() GameTooltip:Hide() end)
Avoidance:SetScript("OnEvent",AV_Update)