if not HissySavedTS.v15 then return end
if HissySavedTS.buffs ~= true then return end
local M = Hissy[1]

ConsolidatedBuffs:ClearAllPoints()
ConsolidatedBuffs:SetPoint("LEFT", Minimap)
ConsolidatedBuffs:SetSize(16, 16)
ConsolidatedBuffsIcon:SetTexture("")
ConsolidatedBuffs.SetPoint = M.null

local rowbuffs = HissySavedTS.rollbuffs
local maxbuff = HissySavedTS.rollbuffs*2
local maxdebuffs = HissySavedTS.rolldebuffs
local bsize = HissySavedTS.buffssize
local desize = HissySavedTS.debuffsize
local fsize = HissySavedTS.bufffont
local defsize = HissySavedTS.debufffont

WorldStateAlwaysUpFrame:SetFrameStrata("BACKGROUND")
WorldStateAlwaysUpFrame:SetFrameLevel(0)

local function StyleBuffs(buttonName, index, debuff)
	local buff		= _G[buttonName..index]
	local icon		= _G[buttonName..index.."Icon"]
	local border	= _G[buttonName..index.."Border"]
	local duration	= _G[buttonName..index.."Duration"]
	local count 	= _G[buttonName..index.."Count"]
	if icon and not _G[buttonName..index.."Panel"] then
		icon:SetTexCoord(.1,.9,.1,.9)
		icon:SetPoint("TOPLEFT")
		icon:SetPoint("BOTTOMRIGHT")
		icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
		
		
		duration:ClearAllPoints()
		duration:SetShadowOffset(1.4,-1.4)
		duration:SetPoint("BOTTOMLEFT",.1,-.7)
		duration:SetJustifyH("LEFT")
		
		count:ClearAllPoints()
		count:SetPoint("TOPRIGHT",1,0)
		count:SetShadowOffset(1,-1)
		
		if not debuff then
			buff:SetSize(bsize,bsize)
			duration:SetFont(M["media"].cdfont,fsize)
			count:SetFont(M["media"].font, fsize-1, "OUTLINE")
		else
			buff:SetSize(desize,desize)
			duration:SetFont(M["media"].cdfont,defsize)
			count:SetFont(M["media"].font, defsize-1, "OUTLINE")
		end
		
		local panel = M.frame(buff,buff:GetFrameLevel() + 2,buff:GetFrameStrata(),true,nil,nil)
		panel:SetPoint("TOPLEFT",-4,4)
		panel:SetPoint("BOTTOMRIGHT",4,-4)
		panel:SetBackdrop({
			edgeFile = M["media"].glow, 
			edgeSize = 4, insets = {left = 3, right = 3, top = 3, bottom = 3}})
		panel:SetBackdropBorderColor(unpack(M["media"].shadow))
		
		_G[buttonName..index.."Panel"] = panel
	end
	if border then border:Hide() end
end

local function UpdateBuffAnchors()
	buttonName = "BuffButton"
	local buff, previousBuff, aboveBuff;
	local numBuffs = 0;
	for index=1, BUFF_ACTUAL_DISPLAY do
		local buff = _G[buttonName..index]
		StyleBuffs(buttonName, index, false)
		
		if ( buff.consolidated ) then
			if ( buff.parent == BuffFrame ) then
				buff:SetParent(ConsolidatedBuffsContainer)
				buff.parent = ConsolidatedBuffsContainer
			end
		else
			numBuffs = numBuffs + 1
			index = numBuffs
			if index > maxbuff then buff:Hide() end
			buff:ClearAllPoints()
			if ( (index > 1) and (mod(index, rowbuffs) == 1) ) then
				if ( index == rowbuffs+1 ) then
					buff:SetPoint("TOPRIGHT", Minimap, "TOPLEFT",-5, -38)
				else
					buff:SetPoint("TOPRIGHT", Minimap, "TOPLEFT",-5, 0)
				end
				aboveBuff = buff;
			elseif ( index == 1 ) then
				buff:SetPoint("TOPRIGHT", Minimap, "TOPLEFT",-5, 0)
			else
				buff:SetPoint("RIGHT", previousBuff, "LEFT", -6, 0)
			end
			previousBuff = buff
		end		
	end
end

local takecolor = function(target,r,g,b)
	target.top:SetTexture(r,g,b)
	target.bottom:SetTexture(r,g,b)
	target.left:SetTexture(r,g,b)
	target.right:SetTexture(r,g,b)
	target:SetBackdropBorderColor(r,g,b,.5)
end

local UpdateDebuffAnchors = M.null
if HissySavedTS.debuffs then
	UpdateDebuffAnchors = function(buttonName, index)
		local debuff = _G[buttonName..index];
		StyleBuffs(buttonName, index, true)
		local dtype = select(5, UnitDebuff("player",index))      
		local color
		if (dtype ~= nil) then
			color = DebuffTypeColor[dtype]
		else
			color = DebuffTypeColor["none"]
		end
		takecolor(_G[buttonName..index.."Panel"],color.r,color.g,color.b)
		debuff:ClearAllPoints()
		if index == 1 then
			debuff:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMLEFT",-5, 0)
		elseif index > maxdebuffs then
			debuff:Hide()
		else
			debuff:SetPoint("RIGHT", _G[buttonName..(index-1)], "LEFT", -6, 0)
		end
	end
else
	UpdateDebuffAnchors = function(buttonName, index)
		_G[buttonName..index]:Hide()
	end
end

hooksecurefunc("DebuffButton_UpdateAnchors", UpdateDebuffAnchors)
hooksecurefunc("BuffFrame_UpdateAllBuffAnchors", UpdateBuffAnchors)

SecondsToTimeAbbrev = function(time)
    local hr, m, text
    if time <= 0 then text = ""
    elseif(time < 3600 and time > 60) then
		hr = floor(time / 3600)
		m = floor(mod(time, 3600) / 60 + 1)
		text = format("|cffffffff%dm|r", m)
    elseif time < 60 then
		m = floor(time / 60)
		text = (m == 0 and format("|cffff1111%.1f|r",time))
    else
		hr = floor(time / 3600 + 1)
		text = format("|cffffffff%dh|r", hr)
    end
    return text
end