if not HissySavedTS.v15 then return end
if HissySavedTS.chat ~= true then return end
local M = Hissy[1]

local replace = string.gsub
local find = string.find
local _G = _G
local type = type
local origs = {}

local AddMessage = function(self, text, ...)
	if(type(text) == "string") then
		text = text:gsub('|h%[(%d+)%. .-%]|h', '|h[%1]|h')
	end
	return origs[self](self, text, ...)
end

FCF_MinimizeFrame = M.null
FCF_RestorePositionAndDimensions = M.null

M.kill(InterfaceOptionsSocialPanelChatStyle)
M.kill(InterfaceOptionsSocialPanelConversationMode)
M.kill(FriendsMicroButton)
M.kill(FriendsMicroButton)
M.kill(GeneralDockManagerOverflowButton)
M.kill(GeneralDockManagerOverflowButton)


-- Player entering the world
M.addenter(function()

	-- editbox background
	local x=({ChatFrame1EditBox:GetRegions()})
	x[9]:SetAlpha(0)
	x[10]:SetAlpha(0)
	x[11]:SetAlpha(0)
	
	SetCVar("chatMouseScroll", 1)
	SetCVar("chatStyle", "classic")
	SetCVar("WholeChatWindowClickable", 0)
	SetCVar("ConversationMode", "inline")
	
	local sbut = M.frame(FirstFrameChat)
	sbut:SetSize(24,24)
	sbut:SetPoint("BOTTOMRIGHT",FirstFrameChat,"TOPRIGHT",-22,-2)

	sbutn = M.setfont(sbut,14)
	sbutn:SetPoint("CENTER",.1,.1)
	sbutn:SetText("S")
	
	_G["ChatMenu"]:HookScript("OnShow",function(self) 
		M.ChangeTemplate(self) 
		M.backcolor(sbut,1, 0.8, 0.15, .5)
		sbutn:SetTextColor(1, 0.8, 0.15)
		self:ClearAllPoints()
		self:SetPoint("BOTTOMLEFT",sbut,"TOPLEFT",0,-2) 
	end)
	
	_G["ChatMenu"]:HookScript("OnHide",function(self) 
		M.backcolor(sbut,0,0,0)
		sbutn:SetTextColor(1, 1, 1)
	end)
	
	ChatFrameMenuButton:SetAllPoints(sbut)
	ChatFrameMenuButton:SetAlpha(0)
	ChatFrameMenuButton:SetScript("OnEnter", function() sbutn:SetTextColor(1, 0.8, 0.15) end)
	ChatFrameMenuButton:SetScript("OnLeave", function() 
		if _G["ChatMenu"]:IsShown() then return end
		sbutn:SetTextColor(1, 1, 1)
	end)
	
	local ki = function(self) self:Hide() end
	
	for i = 1, NUM_CHAT_WINDOWS do
		_G["ChatFrame"..i]:SetClampRectInsets(0,0,0,0)
		-- Hide chat buttons
		M.kill(_G["ChatFrame"..i.."ButtonFrameUpButton"])
		M.kill(_G["ChatFrame"..i.."ButtonFrameDownButton"])
		M.kill(_G["ChatFrame"..i.."ButtonFrameBottomButton"])
		M.kill(_G["ChatFrame"..i.."ButtonFrameMinimizeButton"])
		M.kill(_G["ChatFrame"..i.."ResizeButton"])
		M.kill(_G["ChatFrame"..i.."ButtonFrame"])
		
		-- Hide chat textures backdrop

		for j = 1, #CHAT_FRAME_TEXTURES do
			_G["ChatFrame"..i..CHAT_FRAME_TEXTURES[j]]:SetTexture(nil)
		end

		-- Stop the chat frame from fading out
		_G["ChatFrame"..i]:SetFading(false)

		-- Change the chat frame font
		local _,x = _G["ChatFrame"..i]:GetFont()
		_G["ChatFrame"..i]:SetFont(M["media"].fontn, x)
		
		_G["ChatFrame"..i]:SetFrameStrata("LOW")
		_G["ChatFrame"..i]:SetMovable(true)
		_G["ChatFrame"..i]:SetUserPlaced(true)
		
		if i == 1 then
			local editbox = _G["ChatFrame"..i.."EditBox"]
			local left, mid, right = select(6, editbox:GetRegions())
			left:Hide(); mid:Hide(); right:Hide()
			editbox:ClearAllPoints();
			editbox:SetPoint("BOTTOMLEFT", ChatFrame1, "TOPLEFT", -14, -3)
			editbox:SetPoint("BOTTOMRIGHT", ChatFrame1, "TOPRIGHT", 12, -3)
			editbox:SetAltArrowKeyMode(false)
		end
		
		GeneralDockManager:ClearAllPoints()
		GeneralDockManager:SetPoint("BOTTOMLEFT",FirstFrameChat,"TOPLEFT",0,3)
		GeneralDockManager:SetPoint("BOTTOMRIGHT",FirstFrameChat,"TOPRIGHT",-36,3)
		
		if i ~= 2 then
			origs[_G["ChatFrame"..i]] = _G["ChatFrame"..i].AddMessage
			_G["ChatFrame"..i].AddMessage = AddMessage
		end
	end
	
	-- Remember last channel
	ChatTypeInfo.WHISPER.sticky = 1
	ChatTypeInfo.BN_WHISPER.sticky = 1
	ChatTypeInfo.OFFICER.sticky = 1
	ChatTypeInfo.RAID_WARNING.sticky = 1
	ChatTypeInfo.CHANNEL.sticky = 1
	ChatTypeInfo.SAY.sticky = 1
	ChatTypeInfo.EMOTE.sticky = 1
	ChatTypeInfo.YELL.sticky = 1
	ChatTypeInfo.PARTY.sticky = 1
	ChatTypeInfo.GUILD.sticky = 1
	ChatTypeInfo.RAID.sticky = 1
	ChatTypeInfo.BATTLEGROUND.sticky = 1

	ChatFrame1:SetJustifyH("LEFT")
	-- Position the general chat frame
	ChatFrame1:ClearAllPoints()
	ChatFrame1:SetPoint("BOTTOMLEFT", FirstFrameChat,"BOTTOMLEFT", 6, 6)
	ChatFrame1:SetPoint("TOPRIGHT", FirstFrameChat,"TOPRIGHT", -7, -3)
end)

local function TempChatSkin()
	local chatFrame, chatTab, conversationIcon
	for _, chatFrameName in pairs(CHAT_FRAMES) do
		local frame = _G[chatFrameName]
		if frame.isTemporary then
				chatFrame = frame
				chatTab = _G[chatFrame:GetName().."Tab"]
				
				chatTab.noMouseAlpha = 0
				
				_G[chatFrame:GetName()]:SetClampRectInsets(0,0,0,0)

				M.kill(_G[chatFrame:GetName().."ButtonFrameUpButton"])
				M.kill(_G[chatFrame:GetName().."ButtonFrameDownButton"])
				M.kill(_G[chatFrame:GetName().."ButtonFrameBottomButton"])
				M.kill(_G[chatFrame:GetName().."ButtonFrameMinimizeButton"])
				M.kill(_G[chatFrame:GetName().."ResizeButton"])
				
				if _G[chatFrame:GetName().."ConversationButton"] then
					_G[chatFrame:GetName().."ConversationButton"]:ClearAllPoints()
					_G[chatFrame:GetName().."ConversationButton"]:SetPoint("TOPRIGHT",FirstFrameChat,-2,-2)
					_G[chatFrame:GetName().."ConversationButton"]:SetSize(26,26)
					M.ChangeTemplate(_G[chatFrame:GetName().."ConversationButton"])
					_G[chatFrame:GetName().."ConversationButton"]:SetBackdropBorderColor(0,0,0,0)
					local texture = _G[chatFrame:GetName().."ConversationButton"]:GetNormalTexture()
					texture:SetTexture([=[Interface/Icons/Spell_ChargePositive.blp]=])
					texture:ClearAllPoints()
					texture:SetPoint("TOPLEFT",4,-4)
					texture:SetPoint("BOTTOMRIGHT",-4,4)
					texture:SetTexCoord(.1,.9,.1,.9)
					_G[chatFrame:GetName().."ConversationButton"]:GetPushedTexture():SetTexture("")
				end

				-- Stop the chat frame from fading out
				_G[chatFrame:GetName()]:SetFading(false)
				
				-- Change the chat frame font
				local _,x = _G[chatFrame:GetName()]:GetFont()				
					_G[chatFrame:GetName()]:SetFont(M["media"].fontn,x)
				
				
				-- Set random stuff
				_G[chatFrame:GetName()]:SetFrameStrata("LOW")
				_G[chatFrame:GetName()]:SetMovable(true)
				_G[chatFrame:GetName()]:SetUserPlaced(true)
	
				_G[chatFrame:GetName()]:SetHeight(ChatFrame1:GetHeight())
				_G[chatFrame:GetName()]:SetWidth(ChatFrame1:GetWidth())
				
				M.MakeCopyButton(nil,_G[chatFrame:GetName()])
				
				-- Hide tab texture
				for j = 1, #CHAT_FRAME_TEXTURES do
					_G[chatFrame:GetName()..CHAT_FRAME_TEXTURES[j]]:SetTexture(nil)
				end
				break
		end
	end
end
hooksecurefunc("FCF_OpenTemporaryWindow", TempChatSkin)

-- scroll
local ScrollLines = 1
function FloatingChatFrame_OnMouseScroll(self, delta)
	if delta < 0 then
		if IsShiftKeyDown() then
			self:ScrollToBottom()
		else
			for i = 1, ScrollLines do
				self:ScrollDown()
			end
		end
	elseif delta > 0 then
		if IsShiftKeyDown() then
			self:ScrollToTop()
		else
			for i = 1, ScrollLines do
				self:ScrollUp()
			end
		end
	end
end

-- Lock it all
M.addafter(function()
	local a = 30
	local ch = HissySavedTS.holder_unit
	if ch ~= 0 and ch ~= 1 and ch then
		a = ch
		FCF_SetLocked(_G["ChatFrame"..a],1)
	end
	for i=1, NUM_CHAT_WINDOWS do
		if i ~= a then
			if _G["ChatFrame"..i.."Tab"]:IsShown() then
				local p = _G["ChatFrame"..i]
				FCF_DockFrame(p)
				FCF_SetLocked(p,1)
			end
		end
	end
end)