﻿if not HissySavedTS.v15 then return end
local M = Hissy[1]
HissySavedTS.zone_change = M.check_nil(HissySavedTS.zone_change)
if HissySavedTS.minimap ~= true then return end

local mP = M.frame(Minimap,3,"BACKGROUND")
	mP:SetPoint("TOPRIGHT",4,4)
	mP:SetPoint("BOTTOMLEFT",-3,-4)
	mP:SetBackdropColor(0,0,0,0)
	mP.bg:SetGradientAlpha("VERTICAL",.5,.5,.5,0,0,0,0,.5)
	mP.bg:SetBlendMode("BLEND")

Minimap:SetScale(1)
Minimap:SetFrameStrata("BACKGROUND")
Minimap:ClearAllPoints()
Minimap:SetPoint("TOPRIGHT", -6, -6)	
Minimap:SetFrameLevel(2)
Minimap:SetMaskTexture('Interface\\ChatFrame\\ChatFrameBackground')	
MinimapBorder:Hide()
MinimapBorderTop:Hide()
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
MiniMapVoiceChatFrame:Hide()
GameTimeFrame:Hide()
MinimapNorthTag:SetTexture(nil)
MinimapZoneTextButton:Hide()
MiniMapTracking:Hide()
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPRIGHT", Minimap, 3, 4)
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture("Interface\\AddOns\\HissyMedia\\media\\mail")
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("BOTTOMRIGHT", Minimap, 3, 0)
MiniMapWorldMapButton:Hide()
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetParent(Minimap)
MiniMapInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)
GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetParent(Minimap)
GuildInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)
MiniMapLFGFrameBorder:Hide()
MiniMapBattlefieldBorder:Hide()
StreamingIcon:SetParent(Minimap)
StreamingIcon:ClearAllPoints()
StreamingIcon:SetPoint("BOTTOMLEFT",Minimap,-6,-7)
StreamingIcon.SetPoint = M.null
StreamingIcon:EnableMouse(false)

function UpdateLFG()
	MiniMapLFGFrame:ClearAllPoints()
	MiniMapLFGFrame:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 3, 0)
end
hooksecurefunc("MiniMapLFG_UpdateIsShown", UpdateLFG)

Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function(self, d)
	if d > 0 then
		_G.MinimapZoomIn:Click()
	elseif d < 0 then
		_G.MinimapZoomOut:Click()
	end
end)

Minimap:SetScript("OnMouseUp", function(self, btn)
	if btn == "RightButton" then
		ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self)
	else
		Minimap_OnClick(self)
	end
end)

function GetMinimapShape() return 'SQUARE' end

local set_anim = M.set_anim

local m_zone = M.frame(UIParent,5,"LOW")
	m_zone:SetHeight(20)
	m_zone:SetFrameLevel(5)
	m_zone:SetPoint("TOPLEFT",Minimap)
	m_zone:SetPoint("TOPRIGHT",Minimap)
	
	set_anim(m_zone,true,0,50)
	m_zone:Hide()

local m_zone_text = M.setfont(m_zone,13,nil,nil,"CENTER")
	m_zone_text:SetPoint("TOPLEFT",6,0)
	m_zone_text:SetPoint("BOTTOMRIGHT",-5,0)
	
local m_coord = M.frame(UIParent,5,"LOW")
	m_coord:SetHeight(20)
	m_coord:SetPoint("BOTTOMLEFT",Minimap)
	m_coord:SetWidth(45)
	
	set_anim(m_coord,true,340,0)
	m_coord:Hide()	
	
local m_coord_text = M.setfont(m_coord,13,nil,nil,"CENTER")
	m_coord_text:SetPoint("TOPLEFT",2,0)
	m_coord_text:SetPoint("BOTTOMRIGHT",-1,0)
	
Minimap:SetScript("OnEnter",function()
	m_zone.anim_o:Stop()
	m_coord.anim_o:Stop()
	m_zone:Show()
	m_coord:Show()
	m_coord.anim:Play()
	m_zone.anim:Play()
end)

Minimap:SetScript("OnLeave",function()
	m_coord.anim:Stop()
	m_coord.anim_o:Play()
	m_zone.anim:Stop()
	m_zone.anim_o:Play()
end)

m_coord_text:SetText("00,00")

local ela,go = 0,false

m_coord.anim:SetScript("OnFinished",function() go = true end)
m_coord.anim_o:SetScript("OnPlay",function() go = false end)

local coord_Update = function(self,t)
	ela = ela - t
	if ela > 0 or not(go) then return end
	local x,y = GetPlayerMapPosition("player")
	local xt,yt
	x = math.floor(100 * x)
	y = math.floor(100 * y)
	if x == 0 and y == 0 then
		m_coord_text:SetText("X _ X")
	else
		if x < 10 then 
			xt = "0"..x
		else 
			xt = x 
		end
		if y < 10 then 
			yt = "0"..y 
		else 
			yt = y 
		end
		m_coord_text:SetText(xt..","..yt)
	end
	ela = .2
end

m_coord:SetScript("OnUpdate",coord_Update)

local zone_show_enable = HissySavedTS.zone_change
local territory_colors = M.territory_colors
local GetZoneText = GetZoneText
local GetMinimapZoneText = GetMinimapZoneText
local GetZonePVPInfo = GetZonePVPInfo

local zone_Update = function()
	local text = GetMinimapZoneText()
	local r,g,b = unpack(territory_colors[GetZonePVPInfo() or "none"])
	m_zone_text:SetText(text)
	m_zone_text:SetTextColor(r,g,b)	
	if not(zone_show_enable) then return end
	local p = GetZoneText()
	if p:match(text) then
		text = ""
	else
		text = ": "..text
	end
	M.sl_run(p..text,r,g,b)
end

m_zone:RegisterEvent("PLAYER_ENTERING_WORLD")
m_zone:RegisterEvent("ZONE_CHANGED_NEW_AREA")
m_zone:RegisterEvent("ZONE_CHANGED")
m_zone:RegisterEvent("ZONE_CHANGED_INDOORS")
m_zone:SetScript("OnEvent",zone_Update) 

tinsert(M.enterload,function()
	M.kill(TimeManagerClockButton)
end)

tinsert(M.afterload,zone_Update)

if zone_show_enable then
	M.kill(ZoneTextFrame)
	M.kill(SubZoneTextFrame)
end