﻿if not HissySavedTS.v15 then return end
local M = Hissy[1]

if HissySavedTS.top then
	local top = M.frame(UIParent,1)
		top:SetHeight(18)
		top:SetPoint("TOPRIGHT",5,5)
		top:SetPoint("TOPLEFT",-5,5)
end
if HissySavedTS.bottom then
	local bottom = M.frame(UIParent,1)
		bottom:SetHeight(25)
		bottom:SetPoint("BOTTOMLEFT",-5,-5)
		bottom:SetPoint("BOTTOMRIGHT",5,-5)
end

-- Chat holders
local chatone = M.frame(UIParent,2,nil,nil,nil,nil,"FirstFrameChat")
	chatone:SetPoint("BOTTOMLEFT",2,2)
	chatone:SetWidth(HissySavedTS.ch_w)
	
local chattwo = M.frame(UIParent,2,nil,nil,nil,nil,"SecondFrameChat")
	chattwo:SetPoint("BOTTOMRIGHT",-2,2)
	chattwo:SetWidth(HissySavedTS.ch_w)

HissySavedTS.watch_frame = M.check_nil(HissySavedTS.watch_frame)
if HissySavedTS.watch_frame == true then
	-- Quest log icons
	local update_icons = function()
		for i=1,25 do
			local a = _G["WatchFrameItem"..i]
			if not a then return end
			if not a.bg_ then
					_G["WatchFrameItem"..i.."IconTexture"]:SetTexCoord(.1,.9,.1,.9)
					a:GetNormalTexture():SetTexture("")
					a:GetPushedTexture():SetTexture(.7,.7,.7,.4)
					a:GetHighlightTexture():SetTexture(.6,.6,.6,.2)
				local bg = M.frame(a,nil,nil,true)
					bg:SetBackdropColor(0,0,0,0)
					bg:SetPoint("TOPLEFT",-4,4)
					bg:SetPoint("BOTTOMRIGHT",4,-4)
					bg:SetFrameLevel(a:GetFrameLevel()+2)
					bg:SetFrameStrata(a:GetFrameStrata())
				a.bg_ = bg
			end
		end
	end
	hooksecurefunc("WatchFrame_Update", update_icons)

	-- fix expand
	M.addenter(function()
		local ex = WatchFrameCollapseExpandButton
		ex:SetAlpha(0)
		
		local mask = M.frame(UIParent,5,"HIGH")
		mask:SetPoint("TOPLEFT",ex,-2,3)
		mask:SetPoint("BOTTOMRIGHT",ex,2,-1)
		M.backcolor(mask,1,.7,.1,.4)
		
		if not ex:IsShown() then mask:Hide() end
		
		local text = mask:CreateFontString(nil,"OVERLAY")
		text:SetFont(M["media"].font_s,16)
		text:SetPoint("CENTER",0,1)
		text:SetText("-")
		text:SetTextColor(1,.7,.1)
		
		mask.on = true
		
		ex:HookScript("OnClick",function() 
			if mask.on == true then
				mask.on = false
					text:SetText("+")
					text:SetPoint("CENTER",0,0)
					text:SetTextColor(1,1,1)
					M.backcolor(mask,0,0,0)
			else
				mask.on = true
					text:SetText("-")
					text:SetPoint("CENTER",0,1)
					text:SetTextColor(1,.7,.1)
					M.backcolor(mask,1,.7,.1,.4)
			end
		end)
		
		ex:HookScript("OnShow",function() mask:Show() end)
		ex:HookScript("OnHide",function() mask:Hide() end)
	end)

	-- WatchFrame
	local f = WatchFrame
	f:SetClampedToScreen(false)
	f:ClearAllPoints()
	f.ClearAllPoints = M.null
	local maskframe___ = CreateFrame("Frame",nil,UIParent)
	maskframe___:SetSize(40,1)
	maskframe___:SetPoint("TOPRIGHT",UIParent,-86,-210)
	f:SetPoint("TOPRIGHT",maskframe___,"BOTTOMRIGHT")
	f:SetPoint("BOTTOMRIGHT",UIParent,-86,150)
	f.SetPoint = M.null
	VehicleSeatIndicator:ClearAllPoints()
	VehicleSeatIndicator:SetPoint("TOPRIGHT",maskframe___,"TOPRIGHT",-24,2)
	VehicleSeatIndicator.SetPoint = M.null
	VehicleSeatIndicator.ClearAllPoints = M.null
	VehicleSeatIndicator:HookScript("OnShow",function(self)
		maskframe___:SetHeight(floor(self:GetWidth()))
	end)
	VehicleSeatIndicator:HookScript("OnHide",function(self) 
		maskframe___:SetHeight(1)
	end)

	-- Durability
	M.kill(DurabilityFrame)

	-- Capture Bar
	local function CaptureUpdate()
		if NUM_EXTENDED_UI_FRAMES then
			local captureBar
			for i=1, NUM_EXTENDED_UI_FRAMES do
				captureBar = getglobal("WorldStateCaptureBar" .. i)
				if captureBar and captureBar:IsVisible() then
					captureBar:ClearAllPoints()
					if( i == 1 ) then
						captureBar:SetPoint("TOP",Minimap,"BOTTOM",0,-9)
					else
						captureBar:SetPoint("TOP", getglobal("WorldStateCaptureBar" .. i - 1 ), "TOP", 0, -25)
					end
				end	
			end	
		end
	end
	hooksecurefunc("UIParent_ManageFramePositions", CaptureUpdate)
end

-- Bnet toast fix
BNToastFrame:HookScript("OnShow", function()
	BNToastFrame:ClearAllPoints()
	BNToastFrame:SetPoint("BOTTOM",chatone,"TOP",0,20)
end)

M.setbackdrop(BNToastFrame)
M.style(BNToastFrame,true)
BNToastFrame:SetBackdropColor(.08,.08,.08,.9)

-- Chat swichng system
if HissySavedTS.ch_max < HissySavedTS.ch_min then
	local a = HissySavedTS.ch_max
	HissySavedTS.ch_max = HissySavedTS.ch_min
	HissySavedTS.ch_min = a
end

if HissySavedTS.ch_max == HissySavedTS.ch_min then
	HissySavedTS.ch_max = HissySavedTS.ch_max + 10
end

local max_h = HissySavedTS.ch_max
local min_h = HissySavedTS.ch_min
local speed = HissySavedTS.chat_speed

-- current
local n = {
	[1] = HissySavedTS.chatcur[1],
	[2] = HissySavedTS.chatcur[2], }

local ponti = CreateFrame("Frame")
ponti:SetFrameStrata("MEDIUM")

local strelki = ponti:CreateFontString(nil,"OVERLAY")
strelki:SetFont(M['media'].font_s,36)
ponti:SetScale(2)
strelki:SetPoint("TOP",.3,-4)
strelki:SetTextColor(1,.7,.1)

strelki.yay = strelki:CreateAnimationGroup("IN")
strelki.yay_ = strelki:CreateAnimationGroup("OUT")

do
	local ti = strelki.yay
	for i = 1,2 do
		M.anim_alpha(ti,i == 1 and "c" or "d",i,.6*(i-1),2*(i-1)-1)
		M.anim_trans(ti,i == 1 and "a" or "b",i,.6*(i-1))
	end
	local to = strelki.yay_
		M.anim_alpha(to,"c",1,.6,-1)
		M.anim_trans(to,"a",1,.6)
	to:SetScript("OnFinished",function() ponti:Hide() end)	
end
	
local to_move = function (self,t)
	n[self.num] = n[self.num] + t * self.mod
	if self.change*n[self.num] < self.level_t*self.change then
		self.target:SetHeight(n[self.num])
	else
		self:Hide()
		n[self.num] = self.level_t
		self.target:SetHeight(self.level_t)
	end
end

local direct = function(num)
	if HissySavedTS.chatcur[num] == max_h
		then 	strelki:SetText('\\/ \\/ \\/')
				strelki.yay_.a:SetOffset(0,-60)
				strelki.yay.b:SetOffset(0,-60)
				strelki.yay.a:SetOffset(0,60)
	else
		strelki:SetText('/\\ /\\ /\\')
		strelki.yay_.a:SetOffset(0,60)
		strelki.yay.b:SetOffset(0,60)
		strelki.yay.a:SetOffset(0,-60)
	end
end

local make_ud = function(frame,num,change,level)
	local f = CreateFrame("Frame")
	f:Hide()
	f.level_t = level
	f.target = frame
	f.num = num
	f.mod = speed * change
	f.change = change
	f:SetScript("OnUpdate",to_move)
	return f
end

local fr_button
local mk_frbutton = function(frame,num)
	frame:SetHeight(HissySavedTS.chatcur[num])
	local bt = CreateFrame("Frame",nil,frame)
	if num == 2 then
		fr_button = bt
	end
	bt:SetFrameStrata("MEDIUM")
	bt:SetPoint("TOPLEFT",frame.top,-2,5)
	bt:SetPoint("BOTTOMRIGHT",frame.top,2,-5)
	bt:EnableMouse(true)
	bt.wait = true
	
	strelki.yay:SetScript("OnFinished",function()
		if not(GetMouseFocus()) then return end
		if GetMouseFocus().wait ==  true then return end
		strelki.yay_:Play()
	end)	
	bt:SetScript("OnEnter",function(self) 
		M.backcolor(frame,1,.7,.1,.4)
		ponti:ClearAllPoints()
		ponti:SetAllPoints(frame)
		direct(self.num)
		ponti:Show()
		strelki.yay_:Stop()
		if not (strelki.yay:IsPlaying()) then
			strelki.yay:Play()
		end
	end)
	bt:SetScript("OnLeave",function() 
		M.backcolor(frame,0,0,0)
		if not (strelki.yay_:IsPlaying() or strelki.yay:IsPlaying()) then
			strelki.yay_:Play()
		end
	end)
	
	frame.postupd = M.null
	bt.num = num
	bt.up = make_ud(frame,num,1,max_h)
	bt.down = make_ud(frame,num,-1,min_h)
	
	bt:SetScript("OnMouseDown",function(self)
		frame.postupd()
		if HissySavedTS.chatcur[bt.num] == min_h then
			HissySavedTS.chatcur[bt.num] = max_h
			self.down:Hide()
			self.up:Show()
		else 
			HissySavedTS.chatcur[bt.num] = min_h
			self.up:Hide()
			self.down:Show()
		end
	end)
end

mk_frbutton(chatone,1)
mk_frbutton(chattwo,2)	

local right_holder = CreateFrame("Frame",nil,UIParent)
right_holder:SetHeight(20)
right_holder:SetFrameStrata("LOW")

local moving = function(self,t)
	self.he = self.he + t*self.mult
	if self.he*self.ar < self.ma*self.ar then
		right_holder:ClearAllPoints()
		right_holder:SetPoint("BOTTOMRIGHT",chattwo,0,self.he)
		right_holder:SetPoint("BOTTOMLEFT",chattwo,0,self.he)
	else
		right_holder:ClearAllPoints()
		right_holder:SetPoint(self.point1,chattwo,self.point2,0,self.p)
		right_holder:SetPoint(self.point3,chattwo,self.point4,0,self.p)
		self:Hide()
	end
end

right_holder.mover = CreateFrame("Frame",nil,right_holder)
right_holder.mover:Hide()
right_holder.mover:SetScript("OnUpdate",moving)
chattwo.right_holder = right_holder

local fn_button = CreateFrame("Frame",nil,UIParent)
local work_unit = M.frame(right_holder)
chattwo.work_unit = work_unit

local hld_correct = function(he,ar,ma,mult,p1,p2,p3,p4,x,pi)
	local a = right_holder.mover
	a:Hide()
	a.he = he
	a.ar = ar
	a.ma = ma
	a.p = pi
	a.mult = (a.he + a.ma) * mult 
	a.point1 = p1
	a.point2 = p2
	a.point3 = p3
	a.point4 = p4
	a:Show()
	HissySavedTS.holder_cur = x
	fn_button:ClearAllPoints()
end

right_holder.go_up = function()
	hld_correct(2,1,floor(chattwo:GetHeight()),1,"BOTTOMLEFT","TOPLEFT","BOTTOMRIGHT","TOPRIGHT",1,0)
	UIFrameFadeIn(chattwo,.8,0,1)
	fr_button:EnableMouse(true)
	fn_button:SetPoint("TOPRIGHT",chattwo,5,5)
	fn_button:SetPoint("BOTTOMLEFT",chattwo,"BOTTOMRIGHT",-6,-6)
end

right_holder.go_down = function()
	hld_correct(floor(chattwo:GetHeight()),-1,2,-1,"BOTTOMLEFT","BOTTOMLEFT","BOTTOMRIGHT","BOTTOMRIGHT",0,2)
	UIFrameFadeOut(chattwo,.8,1,0)
	fr_button:EnableMouse(false)
	fn_button:SetAllPoints(work_unit)
	chattwo.update_w(0)
end

local hold_load = function()
	if not HissySavedTS.holder_cur then
		HissySavedTS.holder_cur = 1
	end
	if not HissySavedTS.holder_unit then
		HissySavedTS.holder_unit = 0
	end
	if HissySavedTS.holder_cur == 1 then
		right_holder.go_up()
	else
		right_holder.go_down()
	end
end

work_unit:SetPoint("RIGHT")
work_unit:SetHeight(24)
work_unit:SetFrameLevel(20)

local text_unit = M.setfont(work_unit,12,nil,nil,"CENTER")
text_unit:SetPoint("LEFT",6.4,1)
text_unit:SetPoint("RIGHT",-5.3,1)

right_holder.set_unit = function(text)
	text_unit:SetText(text)
	local a = floor(chattwo:GetWidth()/4)
	local b = string.len(text)*6
	if a < b then
		work_unit:SetWidth(a+13)
	else
		work_unit:SetWidth(b+13)
	end
end

chatone.copyb = CreateFrame("Frame",nil,chatone)
chattwo.copyb = CreateFrame("Frame",nil,right_holder)
chatone.copyb:SetSize(24,24)
chattwo.copyb:SetSize(24,24)
chatone.copyb:SetPoint("BOTTOMRIGHT",chatone,"TOPRIGHT", 0, -2)
chattwo.copyb:SetPoint("LEFT",right_holder)

local lock_chat = function(target)
	if chattwo.curent_unit then
		local a = chattwo.curent_unit
		a.st_g:SetAlpha(1)
		a.tab.lok = nil
		a:SetJustifyH("LEFT")
		a.copyb:ClearAllPoints()
		a.copyb:SetAllPoints(chatone.copyb)
		a.lok = nil
		FCF_DockFrame(a)
	end
	if target == 0 or target == 1 then
		chattwo.curent_unit = nil
		if target == 0 then
			right_holder.set_unit("NaN")
		else
			right_holder.set_unit("OFF")
		end
		chattwo.update_w(0)
	else
		local chat = _G["ChatFrame"..target]
		if not chat then return end
		FCF_UnDockFrame(chat)
		local tab = _G["ChatFrame"..target.."Tab"]
		local a = tab:GetFontString()
		a:SetAlpha(0)
		FCF_SetLocked(chat, 1)	
		tab:HookScript("OnEnter",function(self) if self.lok == true then a:SetAlpha(0); text_unit:SetTextColor(1,.7,.1) end end)
		tab:HookScript("OnLeave",function(self) if self.lok == true then a:SetAlpha(0); text_unit:SetTextColor(1,1,1)end end)
		chat:ClearAllPoints()
		tab.lok = true
		chat.lok = true
		if target == 2 then
			chat:SetPoint("TOPRIGHT", chattwo, -7, -30)
			chat:SetPoint("BOTTOMLEFT", chattwo, 7, 6)
		else
			chat:SetPoint("TOPRIGHT", chattwo, -7, -3)
			chat:SetPoint("BOTTOMLEFT", chattwo, 6, 6)
		end
		chat:SetJustifyH("RIGHT")
		tab:ClearAllPoints() 
		tab:SetAllPoints(work_unit)
		right_holder.set_unit(a:GetText())
		chat.copyb:ClearAllPoints()
		chat.copyb:SetAllPoints(chattwo.copyb)
		chattwo.curent_unit = chat
		chattwo.curent_unit.st_g = a
		chattwo.curent_unit.tab = tab
		chattwo.update_w(1)
	end
end

local check_work_mode = function(rly)
	if HissySavedTS.holder_cur == 1 then
		lock_chat(HissySavedTS.holder_unit)
	else
		if rly then
			lock_chat(HissySavedTS.holder_unit)
			right_holder.go_up()
		else
			lock_chat(1)
		end
	end
end

-- 2 Sceond Countdown
local t2sec = CreateFrame("Frame")
t2sec:Hide()
M.addafter(function() t2sec:Show() end)
local t2n = 2

t2sec:SetScript("OnUpdate",function(self,t)
	t2n = t2n - t
	if t2n > 0 then return end
		self:Hide()
		hold_load()
		check_work_mode()
end)

local menuFrame = CreateFrame("Frame", "LeftChatFrameMenu", UIParent, "UIDropDownMenuTemplate")
local chatframe_menu = function()
	local abc
	if HissySavedTS.holder_unit ~= 0 then
		abc = {{text = "NaN", func = function() HissySavedTS.holder_unit = 0; check_work_mode(true) end},}
	else
		abc = {}
	end
	for i=2, NUM_CHAT_WINDOWS do
		if _G["ChatFrame"..i.."Tab"]:IsShown() and i~=HissySavedTS.holder_unit then
			local a = {text = _G["ChatFrame"..i.."Tab"]:GetFontString():GetText(),
				func = function() HissySavedTS.holder_unit = i; check_work_mode(true) end}
			tinsert(abc,a)
		end
	end
	if HissySavedTS.holder_cur==1 then
		tinsert(abc,{text = "Hide", func = function() right_holder.go_down(); HissySavedTS.holder_unit = 1; check_work_mode()  end})
	end
	return abc
end

fn_button:SetFrameStrata("MEDIUM")
fn_button:EnableMouse(true)

fn_button:SetScript("OnMouseDown",function() EasyMenu(chatframe_menu(), menuFrame, "cursor", 0, 0, "MENU", 2) end)
fn_button:SetScript("OnEnter",function() M.backcolor(chattwo,0,.3,.7,.4); M.backcolor(work_unit,0,.3,.7,.4) end)
fn_button:SetScript("OnLeave",function() M.backcolor(chattwo,0,0,0); M.backcolor(work_unit,0,0,0) end)