MageManaBar = {}

local MageManaBar_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
local MageManaBar1sec_UpdateInterval = 0.5;

MMBLSM = LibStub("LibSharedMedia-3.0") 

local MMBmanapoolmultiplier, MMBtempmanapool, MMBmanaoverflow, MMBbloodelfracial, MMBcurrenttime, MMBprevtime, MMBmanaspent, MMBhplost, MMBTimeToOOM, MMBTimeToDIE, MMBarcaneCD, MMBevocationCD, MMBorbCD, MMBanaGemCD, MMBmanapercent, MMBstep, MMBTagBuild, MMBNewSettings, MMBArcaneBlastStack, MMBArcaneBlastTimer, MMBPower, MMBPowerMax, MMBWastedMana, MMBTotalWastedMana, MMBprevArcaneBlast, MMBAEresetDelay, MMBAEcount, MMBABcount, MMBCastTarget, MMBCastInterrupt, MMBCastAlpha, MMBCastTimeLost, MMBPushback, MMBSavedVariablesDump, MMBErrorSettings

local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical

MMBBaseSettings = {
	{"MageManaBarBgFrame",true,true,1,275,40,{0,0,0,1},true,10,1,true,1,true,1,true,true,true,false,3,false,true},
	-- 1 mana bar frame : frame,enable mana bar,unlock,scale,width,height,color/alpha,background,level,alpha,mana overflow,autohide,markers timers,timer scale, pins colors, enable addon, Wasted mana report, autohide markers, strata, disable tour, enable mouse
	{"MMBInfoFrame1",true,false,7,83,9,{0.25,0.25,0.3,1},true,2,-2,true,25,false,"MageManaBarGlobal"},
	-- 2 info panel 1 : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position, parent frame
	{"MMBInfoFrame2",true,false,7,83,9,{0.25,0.25,0.3,1},true,2,-12,true,26,false,"MageManaBarGlobal"},
	-- 3 info panel 2 : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position, parent frame
	{"MMBInfoFrame3",true,false,7,83,9,{0.25,0.25,0.3,1},true,87,-2,true,2,false,"MageManaBarGlobal"},
	-- 4 info panel 3 : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position, parent frame
	{"MMBInfoFrame4",true,false,7,83,9,{0.25,0.25,0.3,1},true,87,-12,true,27,false,"MageManaBarGlobal"},
	-- 5 info panel 4 : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position, parent frame
	{"MMBInfoFrame5",true,false,7,126,9,{0.25,0.25,0.3,1},true,172,-2,true,18,false,"MageManaBarGlobal"},
	-- 6 info panel 5 : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position, parent frame
	{"MMBInfoFrame6",true,false,7,126,9,{0.25,0.25,0.3,1},true,172,-12,true,17,false,"MageManaBarGlobal"},
	-- 7 info panel 6 : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text, custom position, parent frame
	{"MMBevocation",true,true,35},
	-- 8 evocation timer : frame, enable, icon/timer, position
	{"MMBmanaGem",true,true,12405},
	-- 9 mana gem timer : frame, enable, icon/timer, position
	{"MMBmageArmor",true,true,103,false,true},
	-- 10 mage armor timer : frame, enable, icon/timer, position, frost/fire spec, autohide
	{"MMBArcaneTorrent",true,true,94},
	-- 11 arcane torrent timer : frame, enable, icon/timer, position
	{"MMBOrb",true,true,80},
	-- 12 Flame orb timer : frame, enable, icon/timer, position
	{"MageManaBarInfoFrame",true,true,24,"xx","xx",{0,0,0,1}},
	-- 13 info panel : name, enable, background, height, color/alpha
	{"MMBspellcost",true,0.4},
	-- 14 spellcost : name, enable, alpha
	{"MageManaBarFrame", true, {1,0.2,0.2,1}, {1,0.4,0,1}, {1,0.8,0,1}, {1,1,0,1}, {0.2,0.5,0.8,1}, "Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Fonts\\FRIZQT__.TTF", "Friz Quadrata TT", true},
	-- 15 mana bar : name,bar color change, sub evo color, sub flame orb color, sub gem color, sub arcane torrent color, color/alpha, texture, texture name, font, font name, smooth gradient for color change
	{"MageManaBarOverflowFrame","xx","xx","xx","xx","xx",{1,0.3,0.3,0.5}},
	-- 16 Overflow bar : name, color/alpha,
	{"MageManaBarWarning",true,false,true,230,20,{0.2,0.5,0.86,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Interface\\AddOns\\MageManaBar\\Fonts\\Bazooka.ttf", "Bazooka",15,true,{0,0,0,1},true,{0.25,0.25,0.3,1},20},
	-- 17 warning bar : name, enable, unlock, autohide, width, height, color/alpha, texture, texture name, fontsize, font, font name, background, background color, text Bg, text Bg color, wait time for burn
	{true,true,true,true,true,true,true,false,true},
	-- 18 warning bar contents : burn related, mana gem related, evocation related, flame orb related, next burn related, mana overflow related, overflow in fire/frost spec, autohide OOC, AE watcher
	{"MageManaBarHealth",true,true,15,{1,0.3,0.3,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar"},
	-- 19 health bar : name, enable, Bg, height, color, texture, texture name
	{"MageManaBarWarning","MageManaBarHealth","MageManaBarBgFrame","MageManaBarAlternate","MageManaBarCastFrame","MageManaBarInfoFrame"},
	-- 20 Positionning for frames
	{"MageManaBarCastFrame",true,true,true,20,false,{0.6,0.5,0,1},{0.4,0.3,0.7,1},true,"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Fonts\\FRIZQT__.TTF", "Friz Quadrata TT",8},
	-- 21 cast bar, enable, show icon, target, height, autohide, cast color, channel color, instant cast, texture, texture name, font, fontname, fontsize 
    {"MageManaBarAlternate",true,12,{0.6,0.5,0,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Fonts\\FRIZQT__.TTF", "Friz Quadrata TT",8,true},
    -- 22 Alternate bar, enable, height, color, texture, texture name, font, fontname, fontsize, autohide
}

MMBFrameStrata = {"BACKGROUND","LOW","MEDIUM","HIGH","DIALOG","FULLSCREEN","FULLSCREEN_DIALOG","TOOLTIP"} 

MMBpositionList = {"Position 1","Position 2","Position 3","Position 4","Position 5","Position 6","Hidden"}

MMBpositionDDown = {{"MMBWarningPositionDropDown","MageManaBarWarning"},
				{"MMBHealthPositionDropDown","MageManaBarHealth"},
				{"MMBManaPositionDropDown","MageManaBarBgFrame"},
				{"MMBInfoPositionDropDown","MageManaBarInfoFrame"},
				{"MMBCastPositionDropDown","MageManaBarCastFrame"},
                {"MMBAltPositionDropDown","MageManaBarAlternate"},}
				
MMBInfoFunctionText = {	"",

						"Current HP",
						"Absolute Current HP",
						"Max HP",
						"Absolute Max HP",
						"Cur/Max HP",
						"Absolute Cur/Max HP",
						"Missing HP",
						"Percent HP",

						0,

						
						"",
						"Current mana",
						"Absolute Current mana",
						"Max mana",
						"Absolute Max mana",
						"Cur/Max mana",
						"Cur/Percent mana",
						"Reg Max mana/Max mana",
						"Absolute Cur/Max mana",
						"Missing mana",
						"Percent mana",

						0,

						0,
						
						"",
						"Time To OOM",

						"Time To Die",

						"Mastery",
                        "Spellpower",
}

local MMBcurrentbuff = {}

local MMBSpellCast = {["starttime"] = 0, ["duration"] = 0}
	
local MMBbufflist = {
	
	{"Power Torrent", 74241, 7500},
	{"Volcanic Power", 79476, 18000},
	{"Volcanic Destruction", 89091, 24000},
	{"Lightweave", 75170, 8700},
	{"Lightweave", 55367, 4425},
	{"Synapse Springs", 96230, 7200},
	{"Mark of the firelord", 97007, 19155}
}

local MMBFrameEvents = {["MageManaBarCastFrame"] = {"UNIT_SPELLCAST_SENT",
						"UNIT_SPELLCAST_START",
						"UNIT_SPELLCAST_STOP",
						"UNIT_SPELLCAST_DELAYED",
						"UNIT_SPELLCAST_INTERRUPTED",
						"UNIT_SPELLCAST_CHANNEL_START",
						"UNIT_SPELLCAST_CHANNEL_STOP",
						"UNIT_SPELLCAST_CHANNEL_INTERRUPTED",
						"UNIT_SPELLCAST_CHANNEL_UPDATE"},
                        ["MageManaBarHealth"] = {"UNIT_MAXHEALTH", 
                                                "UNIT_HEALTH"},
                        ["MageManaBarAlternate"] = {"UNIT_POWER_BAR_SHOW", 
                                                "UNIT_POWER_BAR_HIDE"}}
                                            
local MMBprefixtable = {"evocation","manaGem","ArcaneTorrent","mageArmor","Orb"}

local MMBInfoFunctionPrefix = {	"",

							"Curr HP : ",
							"Curr HP : ",
							"Max HP : ",
							"Max HP : ",
							"Cur/Max HP : ",
							"Cur/Max HP : ",
							"Miss HP : ",
							"% HP : ",

							0,

							
							"",
							"Curr mana : ",
							"Curr mana : ",
							"Max mana : ",
							"Max mana : ",
							"Cur/Max mana : ",
							"Cur/% mana : ",
							"Max mana : ",
							"Cur/Max mana : ",
							"Miss mana : ",
							"% mana : ",

							0,

							0,
							
							"",
							"TTOOM : ",

							"TTDie : ",

							"Mastery : ",
                            "Sp : ",

}

function MageManaBar_OnLoad(Frame) 

	if MMBSettings == nil then 
		MMBreset(MMBBaseSettings)
	end

	MMBLSM.RegisterCallback(MageManaBar , "LibSharedMedia_Registered", "SharedMedia_Registered") 
	MMBLSM.RegisterCallback(MageManaBar , "LibSharedMedia_Registered", "SharedMedia_Registered") 
									
	MMBLSM:Register("statusbar","CombuBar","Interface\\AddOns\\MageManaBar\\Images\\combubarblack")
	MMBLSM:Register("font","MSBT Bazooka","Interface\\AddOns\\MageManaBar\\Fonts\\Bazooka.ttf")

	if select(2, UnitClass("player")) ~= "MAGE" then 
        MageManaBarGlobal:Hide() 
        MageManaBarGlobal:SetScript("OnUpdate", nil)
        return 
    end
		
	Frame:RegisterForDrag("LeftButton")
    Frame:RegisterForClicks("LeftButtonUp","RightButtonUp")
	Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
	Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
	Frame:RegisterEvent("PLAYER_TALENT_UPDATE")
	Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	Frame:RegisterEvent("UNIT_MAXPOWER")
	Frame:RegisterEvent("UNIT_POWER")
	Frame:RegisterEvent("PLAYER_ENTERING_WORLD")

	MMBevocationCDAnim = 0
	MMBmanaGemCDAnim = 0
	MMBArcaneTorrentCDAnim = 0
	MMBOrbCDAnim = 0
	MMBmanaGemFlash = 0
	MMBevocationFlash = 0
	MMBArcaneTorrentFlash = 0
	MMBOrbFlash = 0
	MMBmanaGemresize = 0
	MMBevocationresize = 0
	MMBArcaneTorrentresize = 0
	MMBOrbresize = 0
	MMBPower = 0
	MMBPowerMax = 0
	MMBWastedMana = 0
	MMBTotalWastedMana = 0
	MMBArcaneBlastTimer = 0
	MMBprevArcaneBlast = 7
    MMBArcaneBlastStack = 0
    MMBAEresetDelay = 0
    MMBCastInterrupt = 0
    MMBCastAlpha = 0
    MMBCastTimeLost = 0
    MMBPushback = 0
    MMBtourpage = 1
    MMBAEcount = 0
     
 	local showmenu = function()
		ToggleDropDownMenu(1, nil, PlayerFrameDropDown, "cursor");
	end
	SecureUnitButton_OnLoad(MageManaBarGlobal, "player", showmenu);

end

-------------------------------
-- helper function for option panel setup
function MMBOptions_OnLoad(panel)
	panel.name = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBInfoOptions_OnLoad(panel)
	panel.name = "Info Panel Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBMarkersOptions_OnLoad(panel)
	panel.name = "Markers Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBHealthOptions_OnLoad(panel)
	panel.name = "Health Bar Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBManaOptions_OnLoad(panel)
	panel.name = "Mana Bar Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBWarningOptions_OnLoad(panel)
	panel.name = "Warning Panel Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBCastOptions_OnLoad(panel)
	panel.name = "Casting Bar Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBAltOptions_OnLoad(panel)
	panel.name = "Alt Power Bar Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

--------------------------------
-- Helper function for Sharemedia support
function MageManaBar:SharedMedia_Registered()
--	print("prut")
	-- do whatever needs to be done to repaint / refont
end
	
-------------------------------
-- CheckButton function for option panel
function MMBcheckButton(button,row,col)

	if (button:GetChecked() == 1) then 
		(MMBSettings[row])[col] = true 
	elseif (button:GetChecked() == nil) then 
		(MMBSettings[row])[col] = false
	end
	
	MMBFrameResize()
end

function MMBcheckButtonOnload(button,row,col)

	if ((MMBSettings[row])[col] == true) then
		button:SetChecked(true)
	elseif ((MMBSettings[row])[col] == false) then
		button:SetChecked(false)
	end
end

local function MMBCallback (restore)

	local newR, newG, newB, newA;
	
	if restore then
		newR, newG, newB, newA = unpack(restore);
	else newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB()
	end
	
	((MMBSettings[MMBpickerrow])[MMBpickercol])[1],((MMBSettings[MMBpickerrow])[MMBpickercol])[2],((MMBSettings[MMBpickerrow])[MMBpickercol])[3],((MMBSettings[MMBpickerrow])[MMBpickercol])[4] = newR, newG, newB, newA
	_G[MMBpickerbutton:GetName().."SwatchTexture"]:SetVertexColor(unpack((MMBSettings[MMBpickerrow])[MMBpickercol]))
	MMBFrameResize()
	
end

-------------------------------
-- Color picker function
function MMBColorPicker(button,row,col)

	MMBpickercol = col
	MMBpickerrow = row
	MMBpickerbutton = button
	ColorPickerFrame:SetColorRGB(((MMBSettings[row])[col])[1],((MMBSettings[row])[col])[2],((MMBSettings[row])[col])[3]);
	ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (((MMBSettings[row])[col])[4] ~= nil), ((MMBSettings[row])[col])[4];
	ColorPickerFrame.previousValues = {((MMBSettings[row])[col])[1],((MMBSettings[row])[col])[2],((MMBSettings[row])[col])[3],((MMBSettings[row])[col])[4]};
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = MMBCallback, MMBCallback, MMBCallback;
	ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
	ColorPickerFrame:Show();

end

-------------------------------
-- Reset savedvariables function
function MMBreset(sourcetable)
	
	if sourcetable == MMBBaseSettings then 
		MMBSettings = {}
	end
	
	for i = 1,#sourcetable do
	
		if not MMBSettings[i] then
			MMBSettings[i] = {}
        elseif i == 20 then
            MMBSettings[20] = {}
		end
		
		for z = 1,#sourcetable[i] do
		
			if type((sourcetable[i])[z]) == "table" then
			
				if not (MMBSettings[i])[z] then
					(MMBSettings[i])[z] = {}
				end 
				
				for x = 1,#(sourcetable[i])[z] do
					((MMBSettings[i])[z])[x] = ((sourcetable[i])[z])[x]
				end
				
			else (MMBSettings[i])[z] = (sourcetable[i])[z]
			end
			
		end
	end
	
	if (select(2, UnitRace("player")) == "BloodElf") then
		(MMBSettings[11])[2] = true
	else (MMBSettings[11])[2] = false
	end
	
	if sourcetable == MMBBaseSettings then
		MageManaBarGlobal:ClearAllPoints() 
		MageManaBarGlobal:SetPoint("CENTER",UIParent,"CENTER",0,0)
	end
	
--	print("MageManaBar settings have been reset.")

end

local function MMBNumberConvert(value)

   if value > 999 then
      return format("%.1fk", value / 1000)
   else return format("%.0f", value)
   end

end

function MMBNewSettingsCheck()

	MMBNewSettings = 0
	
	for i = 1,#MMBBaseSettings do
	
		if MMBSettings[i] == nil then
			MMBSettings[i] = {}
		end
 
		for z = 1,#MMBBaseSettings[i] do
		
			if type((MMBBaseSettings[i])[z]) == "table" and (MMBSettings[i])[z] == nil then

				(MMBSettings[i])[z] = {}

				for x = 1,#(MMBBaseSettings[i])[z] do
				
					((MMBSettings[i])[z])[x] = ((MMBBaseSettings[i])[z])[x]
					MMBNewSettings = MMBNewSettings + 0.25
				end
			
			elseif type((MMBSettings[i])[z]) ~= type((MMBBaseSettings[i])[z]) and (MMBBaseSettings[i])[z] ~= "xx" then
  
                if i == 20 and MMBSettings[i] ~= nil then
  --                  print("prut",i,z);   
                else (MMBSettings[i])[z] = (MMBBaseSettings[i])[z]
                    MMBNewSettings = MMBNewSettings + 1
  --                  print(i,z);   
                end
            end
		end
		
	end
	
	if MMBNewSettings > 0 then
		print(format(" -- %.0f new settings have been loaded for MageManaBar, check option panel to see the new features. --", MMBNewSettings))
	end

end

local function MMBInfoCoords(frame,var)
        
    for i = 1,#MMBSettings[20] do

        if _G[(MMBSettings[20])[i]]:IsShown() and select(2,frame:GetCenter()) > _G[(MMBSettings[20])[i]]:GetBottom() and select(2,frame:GetCenter()) < _G[(MMBSettings[20])[i]]:GetTop() then
        
            (MMBSettings[var])[14] = (MMBSettings[20])[i]
            break
        end
    end

	(MMBSettings[var])[9] = tonumber(format("%.0f", frame:GetLeft() - _G[(MMBSettings[var])[14]]:GetLeft()));
	(MMBSettings[var])[10] = tonumber(format("%.0f", frame:GetTop() - _G[(MMBSettings[var])[14]]:GetTop()));
	_G[frame:GetName().."Xvalue"]:SetText((MMBSettings[var])[9])
	_G[frame:GetName().."Yvalue"]:SetText((MMBSettings[var])[10])

end

local function MMBInfoFramesResize()

	local MMBinfowidth = ((MMBSettings[1])[5]-4)/7
	local MMBinfoheight = ((MMBSettings[13])[4]-3)/2

	for i = 1,6 do
    
        if (MMBSettings[i+1])[13] == false then
        
			if (i < 5) then
                (MMBSettings[i+1])[9] = MMBinfowidth*2
			else (MMBSettings[i+1])[9] = MMBinfowidth*3
			end
            
            (MMBSettings[i+1])[10] = MMBinfoheight
            
			_G["MMBInfoFrame"..i]:SetHeight(MMBinfoheight);
			_G["MMBInfoFrame"..i]:SetWidth((MMBSettings[i+1])[9]);
            
			if (i == 1) or (i == 3) or (i == 5) then
				MMBcoordH = 1
			else MMBcoordH = 2 + MMBinfoheight
			end
			
			MMBcoordW = ceil(i/2) + ((ceil(i/2)-1) * (MMBinfowidth*2)) 
            
			_G["MMBInfoFrame"..i]:ClearAllPoints()
			_G["MMBInfoFrame"..i]:SetPoint("TOPLEFT", MageManaBarInfoFrame, "TOPLEFT", MMBcoordW, 0-MMBcoordH)
            _G["MMBInfoFrame"..i]:SetParent(MageManaBarInfoFrame)
        else 
            _G["MMBInfoFrame"..i]:ClearAllPoints()
            _G["MMBInfoFrame"..i]:SetPoint("TOPLEFT",_G[(MMBSettings[i+1])[14]],"TOPLEFT",(MMBSettings[i+1])[9],(MMBSettings[i+1])[10])
            _G["MMBInfoFrame"..i]:SetParent(_G[(MMBSettings[i+1])[14]])
            _G["MMBInfoFrame"..i]:SetFrameLevel(_G[(MMBSettings[i+1])[14]]:GetFrameLevel()+7)

            if (MMBSettings[i+1])[14] == "MageManaBarGlobal" then
            	MMBInfoCoords(_G[(MMBSettings[i+1])[1]],i+1)
--~                 for i = 1,#MMBSettings[20] do
--~                     if _G[(MMBSettings[20])[i]]:IsShown() and select(2,_G["MMBInfoFrame"..i]:GetCenter()) > _G[(MMBSettings[20])[i]]:GetBottom() and select(2,_G["MMBInfoFrame"..i]:GetCenter()) < _G[(MMBSettings[20])[i]]:GetTop() then
--~                        (MMBSettings[i+1])[14] = (MMBSettings[20])[i]
--~                         break
--~                     end
--~                 end
            end 
           
        end
		
    end
end

local function MMBSpellcastManaCost()

	if UnitCastingInfo("player") then
		MMBcurrentSpellcost = select(4,GetSpellInfo(select(1,UnitCastingInfo("player"))))
	else MMBcurrentSpellcost = nil
	end
	
	if (MMBcurrentSpellcost ~= nil) then
		MMBspellcost:Show()
		MMBspellcost:ClearAllPoints()
		MMBspellcost:SetPoint("TOPRIGHT",MageManaBarFrame,"TOPLEFT", (MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+1,0)
		MMBspellcost:SetWidth((MageManaBarOverflowFrame:GetWidth()*(MMBcurrentSpellcost/UnitPowerMax("player")))+1)
	else MMBspellcost:Hide()
	end
end
	
local function MMBhealthUpdate()

	MageManaBarHealthBar:SetMinMaxValues(0,UnitHealthMax("player"))
	if UnitIsDeadOrGhost("player") then 
        MageManaBarHealthBar:SetValue(0)
    else MageManaBarHealthBar:SetValue(UnitHealth("player"))
    end
    
end

local function MMBManabarUpdate()

    if ((MMBSettings[1])[11] == true) then
		MageManaBarOverflowFrame:SetValue(UnitPower("player"))
	end

	if UnitIsDeadOrGhost("player") then 
        MageManaBarFrame:SetValue(0)
        MageManaBarOverflowFrame:SetValue(0)
    else MageManaBarFrame:SetValue(UnitPower("player"))
	end
    
end

local function MMBAltPowerBarUpdate(event)
    
    if UnitAlternatePowerInfo("player") then
    
        if event == "UNIT_MAXPOWER" then
            
            MageManaBarAlternateBar:SetMinMaxValues(select (2,UnitAlternatePowerInfo("player")), UnitPowerMax("player", ALTERNATE_POWER_INDEX))
            
        elseif event == "UNIT_POWER" then
            
            MageManaBarAlternateBar:SetValue(UnitPower("player",ALTERNATE_POWER_INDEX))
            MageManaBarAlternateText:SetText(format("%s : %.0f%%", select(10,UnitAlternatePowerInfo("player")), (UnitPower("player",ALTERNATE_POWER_INDEX) / UnitPowerMax("player",ALTERNATE_POWER_INDEX))*100))
            
        end
        
    else MageManaBarAlternateBar:SetValue(0)
        MageManaBarAlternateText:SetText("Alt power : 0%")
    end
end

local function MMBAutohideManager(frame,method)

	if method == "hide" then
	
		for i = 1,#MMBSettings[20] do

            if (MMBSettings[20])[i] == frame then

                for z = 0,#MMBSettings[20]-i do 
 -- print(method,z)             

                	if (MMBSettings[20])[i+z] and _G[(MMBSettings[20])[i+z]]:IsShown() then
                   
                        if i == 1 then --print(method,"top")
                            --_G[(MMBSettings[20])[i+z]]:ClearAllPoints()
                            --_G[(MMBSettings[20])[i+z]]:SetPoint("TOP", select(2,_G[frame]:GetPoint()), "TOP", 0,0)
	                        break
                        else  _G[(MMBSettings[20])[i+z]]:ClearAllPoints() --print(method,"bot")
                            _G[(MMBSettings[20])[i+z]]:SetPoint("TOP", select(2,_G[frame]:GetPoint()), "BOTTOM", 0,0)
	                        break
                        end

                    end
                end
       			break

			end
			
		end
	
	elseif method == "show" then
	
		for i = 1,#MMBSettings[20] do
		
			if (MMBSettings[20])[i] == frame then
--print(frame)			
                for z = 1,i do
--print(method,z)
                	if i == 1 then --print(method,"top")
						--_G[frame]:ClearAllPoints()
						--_G[frame]:SetPoint("TOP", MageManaBarGlobal, "TOP", 0,0)
	                	break
                	elseif (MMBSettings[20])[i-z] and _G[(MMBSettings[20])[i-z]]:IsShown() then -- attach the frame to upper frame
						_G[frame]:ClearAllPoints()
						_G[frame]:SetPoint("TOP", (MMBSettings[20])[i-z], "BOTTOM", 0,0) --print(method,"bot")
	                	break
                	end
                end
                
                for z = 1,#MMBSettings[20]-i do
                    
                	if (MMBSettings[20])[i+z] and _G[(MMBSettings[20])[i+z]]:IsShown() then -- attach the frame below to the showed frame
                                      
                        _G[(MMBSettings[20])[i+z]]:ClearAllPoints() --print(method,"attach")
                        _G[(MMBSettings[20])[i+z]]:SetPoint("TOP", _G[frame], "BOTTOM", 0,0)
                        break

                    end
                end
				break
			end
		end
	end

end

local function MMBManabarMaxPool()

	MMBmanapoolmultiplier = 1.05
	MMBtempmanapool = 0

	for i = 1,40 do
	
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", i)
		
		if (spellId == 79060) or (spellId == 79061) or (spellId == 79062) or (spellId == 79063) or (spellId == 90363) or (spellId == 79833)  then
			MMBmanapoolmultiplier = MMBmanapoolmultiplier*1.05
		elseif (spellId == 69378) then
			MMBmanapoolmultiplier = MMBmanapoolmultiplier*1.04
		elseif spellId then
			for z = 1,#MMBbufflist do
				if (spellId == (MMBbufflist[z])[2]) then
					MMBtempmanapool = MMBtempmanapool + (MMBbufflist[z])[3]
				table.insert(MMBcurrentbuff,{expirationTime,name,duration,(MMBbufflist[z])[3]})
					break
				end
			end	
		else break
		end
	end
	
	if (#MMBcurrentbuff ~= 0) then
	
		for i = #MMBcurrentbuff,1,-1 do
			
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", (MMBcurrentbuff[i])[2])
			if (name == nil) then
			table.remove(MMBcurrentbuff,i)
			end
		end
	end
	
	MMBtempmanapool = (MMBtempmanapool * MMBmanapoolmultiplier)
	MMBregmanapool = UnitPowerMax("player")-MMBtempmanapool
	MageManaBarFrame:SetMinMaxValues(0,MMBregmanapool)
	MageManaBarOverflowFrame:SetWidth(MageManaBarFrame:GetWidth() * (UnitPowerMax("player")/MMBregmanapool ))
	MageManaBarOverflowFrame:SetMinMaxValues(0,UnitPowerMax("player"))
	
	MMBmanaGem:ClearAllPoints()
	MMBmanaGem:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((MMBSettings[9])[4]/MMBregmanapool)),0)
	MMBevocation:ClearAllPoints()
	MMBevocation:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[8])[4])/100)),0)
	MMBArcaneTorrent:ClearAllPoints()
	MMBArcaneTorrent:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[11])[4])/100)),0)
	MMBOrb:ClearAllPoints()
	MMBOrb:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[12])[4])/100)),0)
	MMBOrb:ClearAllPoints()
	MMBOrb:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[12])[4])/100)),0)

end

local function MMBArcaneExplosionHide ()

	for i = 1,10 do

        if _G["MMBAEIcon"..i] then
            _G["MMBAEIcon"..i]:Hide()
        end
	end
    MMBAEcount = 0
end

local function MMBArcaneExplosionWatch (spellId, event)

	local name, _, _, count, _, _, expirationTime, _, _, _, _ = UnitAura("player",select(1,GetSpellInfo(36032)),nil,"HARMFUL")
	
	if name then 
		MMBArcaneBlastStack = count
		MMBArcaneBlastTimer = (expirationTime - GetTime())
	else MMBArcaneBlastStack = 0
		MMBArcaneBlastTimer = 0
	end
		
	if (MMBArcaneBlastStack > 0) and MMBAEcount > 0 then
		MageManaBarWarningBar:SetMinMaxValues(0,6)
		MageManaBarWarningBar:SetValue(MMBArcaneBlastTimer)
		MageManaBarWarningBar2:SetMinMaxValues(0,6)
		MageManaBarWarningBar2:SetStatusBarColor(1,0,0,0.8)
		
		if (MMBArcaneBlastTimer <= select(7,GetSpellInfo(30451))/1000) then
			MageManaBarWarningBar2:SetValue(MMBArcaneBlastTimer)
		else MageManaBarWarningBar2:SetValue(select(7,GetSpellInfo(30451))/1000)						
		end
		
        if MMBprevArcaneBlast < MMBArcaneBlastTimer then
            MMBArcaneExplosionHide ()
            MMBAEresetDelay = 0.5
        end
        
        if MMBAEresetDelay == 0.5 and MMBArcaneBlastTimer < 5.5 then
       		MMBAEcount = 0
            MMBAEresetDelay = 0
        end
        
--        print(MMBprevArcaneBlast, MMBArcaneBlastTimer)
        MMBprevArcaneBlast = MMBArcaneBlastTimer
        
	else MMBAEcount = 0
        MMBArcaneExplosionHide ()
        MMBprevArcaneBlast = 7

	end

	if (spellId == 1449) and (event == "SPELL_CAST_SUCCESS") then -- arcane explosion cast
	
		MMBAEcount = MMBAEcount + 1
		MMBABcount = 0
        MMBAEresetDelay = 0
--        print("AE",event)

		
		if MMBArcaneBlastTimer ~= 0 then

			if not _G["MMBAEIcon"..MMBAEcount] then
				CreateFrame("frame", "MMBAEIcon"..MMBAEcount, MageManaBarWarningBar2, "MMBarcaneexplosionTemplate")
				CreateFrame("Cooldown","MMBAEIcon"..MMBAEcount.."Cooldown",_G["MMBAEIcon"..MMBAEcount])
				_G["MMBAEIcon"..MMBAEcount.."Cooldown"]:SetAllPoints(_G["MMBAEIcon"..MMBAEcount])
				_G["MMBAEIcon"..MMBAEcount.."Cooldown"].noCooldownCount = true
			else _G["MMBAEIcon"..MMBAEcount]:Show()
			end
			
			_G["MMBAEIcon"..MMBAEcount]:SetHeight((MMBSettings[17])[6]-3)
            
            local MMBAEgcd = (1.5/((UnitSpellHaste("player")/100)+1))
            
            if select(5,GetTalentInfo(1,16)) == 1 then
                MMBAEgcd = MMBAEgcd - 0.3
            elseif select(5,GetTalentInfo(1,16)) == 2 then
                MMBAEgcd = MMBAEgcd - 0.5
            end
            
            if MMBAEgcd < 1 then
                MMBAEgcd = 1
            end
            
			_G["MMBAEIcon"..MMBAEcount]:SetWidth(((MMBSettings[17])[5]-4)*(MMBAEgcd/6))
			
			_G["MMBAEIcon"..MMBAEcount]:ClearAllPoints()
			_G["MMBAEIcon"..MMBAEcount]:SetPoint("RIGHT", MageManaBarWarningBar2, "LEFT", ((select(7,UnitAura("player",select(1,GetSpellInfo(36032)),nil,"HARMFUL")) - GetTime())/6)*((MMBSettings[17])[5]-4), 0)
--			print (MMBAEcount, MMBArcaneBlastTimer, ((select(7,UnitAura("player",select(1,GetSpellInfo(36032)),nil,"HARMFUL")) - GetTime())/6),(MMBArcaneBlastTimer/6)*((MMBSettings[17])[5]-4))
			
			_G["MMBAEIcon"..MMBAEcount.."Cooldown"]:SetCooldown(0,(1.5*((GetCombatRatingBonus(20)/100)+1)))
			
		end
		
	elseif (spellId == 5143) and (event == "SPELL_CAST_SUCCESS") then -- arcane missiles cast

		MMBAEcount = 0
		MMBABcount = 2

	elseif (spellId == 30451) and (event == "SPELL_DAMAGE") then --and MMBArcaneBlastStack >= 4 then -- arcane blast hit

		MMBABcount = MMBABcount + 1
    --    MMBAEcount = 0
    end
	
	return "  "
    
end

local function MMBGlobalAutohideCheck()

    if (MMBSettings[22])[2] == true then -- autohide for alt power bat
        
        if UnitAlternatePowerInfo("player") or (MMBSettings[22])[10] == false then
            MageManaBarAlternate:Show()
            MMBAutohideManager("MageManaBarAlternate","show")
            MMBAltPowerBarUpdate("UNIT_MAXPOWER")
            MMBAltPowerBarUpdate("UNIT_POWER")
        elseif (MMBSettings[22])[10] == true and MageManaBarAlternate:IsShown() then
            MageManaBarAlternate:Hide()
            MMBAutohideManager("MageManaBarAlternate","hide")
        end
        
    end

    if (MMBSettings[21])[2] == true then -- autohide for cast bar
        
        if UnitCastingInfo("player") or UnitChannelInfo("player") then 
            MageManaBarCastFrame:Show()
        elseif (MMBSettings[21])[6] == true and MageManaBarCastFrame:IsShown() then 
            MageManaBarCastFrame:Hide()
            MMBAutohideManager("MageManaBarCastFrame","hide")
        elseif (MMBSettings[21])[6] == false and not MageManaBarCastFrame:IsShown() then 
            MageManaBarCastFrame:Show()
            MMBAutohideManager("MageManaBarCastFrame","show")
        end
        
    end

end

local function MMBwarning()

	if select(2,GetSpellCooldown(12042)) > 1.6 then MMBarcaneCD = select(2,GetSpellCooldown(12042))-(GetTime()-select(1,GetSpellCooldown(12042)))
	else MMBarcaneCD = 0
	end
	
	if select(2,GetSpellCooldown(12051)) > 1.6 then MMBevocationCD = select(2,GetSpellCooldown(12051))-(GetTime()-select(1,GetSpellCooldown(12051)))
	else MMBevocationCD = 0
	end
	
	if select(2,GetSpellCooldown(5405)) > 1.6 then MMBmanaGemCD = select(2,GetSpellCooldown(5405))-(GetTime()-select(1,GetSpellCooldown(5405)))
	else MMBmanaGemCD = 0
	end
	
	if select(2,GetSpellCooldown(82731)) > 1.6 then MMBorbCD = select(2,GetSpellCooldown(82731))-(GetTime()-select(1,GetSpellCooldown(82731)))
	else MMBorbCD = 0
	end
	
	MMBmanapercent = (UnitPower("player")/MMBregmanapool)*100
	
	local text
	local MMBEvoWait = (MMBSettings[17])[17]
	local MMBEvoBurn = (select(2,GetSpellCooldown(12051))-MMBEvoWait)
	
    MMBoverflow = 0
    
		
	if (MMBAEcount > 0) and (MMBSettings[18])[9] == true then
	
		text = MMBArcaneExplosionWatch ()
		
	elseif (UnitPower("player") > (UnitPowerMax("player")-MMBtempmanapool)) and ((MMBSettings[18])[6] == true) then -- warning when mana overflow
	
		for i = #MMBcurrentbuff,1,-1 do
		
			MMBmanaoverflow = (UnitPower("player")-(UnitPowerMax("player")-MMBtempmanapool))
			MMBbuffoverflowtimer = (MMBcurrentbuff[i])[1]-GetTime()
			
			if (MMBmanaoverflow > 0) then
					text = format("|cffff0000OVERFLOW : %s / %.1fs|r", MMBNumberConvert(MMBmanaoverflow), MMBbuffoverflowtimer)
				MageManaBarWarningBar:SetMinMaxValues(0,(MMBcurrentbuff[i])[3])
				MageManaBarWarningBar:SetValue(MMBbuffoverflowtimer)
				break
			elseif ((MMBcurrentbuff[i])[4] <= MMBmanaoverflow) then
				MMBmanaoverflow = MMBmanaoverflow - (MMBcurrentbuff[i])[4]
			end
		end
		
		MMBoverflow = 1
		MageManaBarWarningBar2:SetValue(0)
	
	elseif (GetPrimaryTalentTree() == 1) and MMBAEcount == 0 then
    
        if UnitAffectingCombat("player") then
		
            if UnitAura("player", select(1,GetSpellInfo(12051))) and ((MMBSettings[18])[3] == true) then -- warning for evocation running
                text = format("|cffffffffEvocating...|r")
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBarcaneCD > 75) and (MMBmanaGemCD == 0) and (GetItemCount(36799, false,true) ~= 0) and ((MMBSettings[18])[2] == true) then -- warning for mana gem use when AP running
                text = format("|cffffffffBurning, use gem now !!|r")
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBorbCD == 0) and (MMBevocationCD > MMBEvoWait) and (MMBmanapercent < (MMBSettings[12])[4]) and ((MMBSettings[18])[4] == true) then -- warning for orb regen phase
                text = format("|cffffffff%.0f%% mana reached, use Orb now !!|r", (MMBSettings[12])[4])
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBorbCD == 0) and (MMBevocationCD > MMBEvoWait) and ((MMBSettings[18])[4] == true) then -- warning for orb burn phase
                text = format("|cffffffffOrb phase, mana at %.1f%%|r", MMBmanapercent)
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBorbCD > 45) and (MMBevocationCD > MMBEvoWait) and ((MMBSettings[18])[4] == true) then -- warning for orb AM Spam phase
                text = format("|cffffffffAM spam, next burn in %.1f|r", MMBevocationCD-MMBEvoWait)
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBarcaneCD == 0) and (MMBevocationCD <= MMBEvoWait) and ((MMBSettings[18])[1] == true) then -- warning when burn phase is ready
                text = format("|cffffffffBurn phase ready...|r")
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBevocationCD == 0) and (MMBmanapercent < (MMBSettings[8])[4]) and ((MMBSettings[18])[3] == true) then -- warning when evocation mark reached
                text = format("|cffffffff%.0f%% mana reached, Evocate now !!|r",(MMBSettings[8])[4])
                MageManaBarWarningBar:SetValue(0)
            elseif (MMBevocationCD > MMBEvoWait) and (MMBarcaneCD+MMBEvoWait < MMBevocationCD) and ((MMBSettings[18])[5] == true) then -- warning when waiting for next burn phase
                text = format("|cffffffffNext burn phase in %.1f|r", MMBevocationCD-MMBEvoWait)
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn)
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
            elseif (MMBarcaneCD > 0) and (MMBevocationCD < MMBEvoWait) and ((MMBSettings[18])[1] == true) then -- warning for burn phase
                text = format("|cffffffffBurning, mana at %.1f%%|r", MMBmanapercent)
                MageManaBarWarningBar:SetValue(0)
            else text = ""
                MageManaBarWarningBar:SetValue(0)
            end
            
        elseif (MMBarcaneCD == 0) and (MMBevocationCD <= MMBEvoWait) and ((MMBSettings[18])[1] == true) then -- warning when burn phase is ready
                text = format("|cffffffffBurn phase ready...|r")
                MageManaBarWarningBar:SetValue(0)
        elseif (MMBevocationCD > MMBEvoWait) and (MMBevocationCD-MMBEvoWait > MMBarcaneCD) and ((MMBSettings[18])[5] == true) then -- warning when waiting for next burn phase
                text = format("|cffffffffNext burn phase in %.1f|r", MMBevocationCD-MMBEvoWait) 
                MageManaBarWarningBar:SetMinMaxValues(0,MMBEvoBurn) 
                MageManaBarWarningBar:SetValue(MMBevocationCD-MMBEvoWait)
        elseif (MMBarcaneCD > 0) and ((MMBSettings[18])[5] == true) then -- warning when waiting for next burn phase
                text = format("|cffffffffNext burn phase in %.1f|r", MMBarcaneCD) 
                MageManaBarWarningBar:SetMinMaxValues(0,select(2,GetSpellCooldown(12042))) 
                MageManaBarWarningBar:SetValue(MMBarcaneCD)
        else text = ""
            MageManaBarWarningBar:SetValue(0)
        end
        
        MMBAEcount = 0
		MageManaBarWarningBar2:SetValue(0)

	else text = ""
		MageManaBarWarningBar:SetValue(0)
		MageManaBarWarningBar2:SetValue(0)
	end

	if not UnitAffectingCombat("player") and (MMBSettings[18])[8] == true then 
        
        if MageManaBarWarning:IsShown() then --print("ooc hide")
            MageManaBarWarning:Hide()
            MMBAutohideManager("MageManaBarWarning","hide")
        end

    elseif (text == "") and ((MMBSettings[17])[4] == true) then
  
        if MageManaBarWarning:IsShown() then --print("rien hide")  
            MageManaBarWarning:Hide()
            MMBAutohideManager("MageManaBarWarning","hide")
        end
        
    elseif not MageManaBarWarning:IsShown() and ((MMBSettings[17])[2] == true) then --print("end show")
		MageManaBarWarning:Show()
        MMBAutohideManager("MageManaBarWarning","show")
	end 
	
	MageManaBarWarningText:SetText(text)
	
    if MMBoverflow == 1 then
		MageManaBarWarningBar:SetStatusBarColor(1,0.5,0.8,0.5)
	else MageManaBarWarningBar:SetStatusBarColor(unpack((MMBSettings[17])[7]))
	end

end

local function MMBmanabarcolorchange()

	if MMBmanapercent then
		if (MMBmanapercent < (MMBSettings[8])[4]) and (MMBSettings[8])[2] == true then -- evocation mark
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[3]))
		elseif (MMBmanapercent < (MMBSettings[12])[4]) and (MMBSettings[12])[2] == true then -- flame orb mark
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[4]))
		elseif (UnitPower("player") < (MMBregmanapool - (MMBSettings[9])[4])) and (MMBSettings[9])[2] == true then -- mana gem mark
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[5]))
		elseif (MMBmanapercent < (MMBSettings[11])[4]) and (MMBSettings[11])[2] == true then -- arcane torrent
			MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[6]))
		else MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[7])) -- full mana color
		end
	end

end

local function MMBSpellTimer(prefix,spellId)

	local start, duration, enable = GetSpellCooldown(spellId)
		
	if (duration > 1.55) and (_G["MMB"..prefix.."CDAnim"] == 0) then
		_G["MMB"..prefix.."Cooldown"]:SetCooldown(start,duration)
		_G["MMB"..prefix.."CDAnim"] = 1
	elseif (duration == 0) and (_G["MMB"..prefix.."CDAnim"] == 1) then
		_G["MMB"..prefix.."gradCooldown"]:SetCooldown(0,0)
		_G["MMB"..prefix.."CDAnim"] = 0
	end
	
	if (duration > 1.55) and (MMBSettings[1])[13] == true and (MMBSettings[1])[18] == false then
	
        _G["MMB"..prefix]:Show()
		MMBspellCD = tonumber(format("%.0f",duration-(GetTime()-start)))
		
		local filename, fontHeight, flags = _G["MMB"..prefix.."Timer"]:GetFont()
		local MMBfontscale = (MMBSettings[1])[14]
		
		if (MMBspellCD < 10) then
		
		if (_G["MMB"..prefix.."Flash"] < 3) then
			_G["MMB"..prefix.."Timer"]:SetText(format("|cffff0000%.0f|r",MMBspellCD))
			_G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
		elseif (_G["MMB"..prefix.."Flash"] < 6) then
			_G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
			_G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
		else  _G["MMB"..prefix.."Flash"] = 1
		end
		
		if (_G["MMB"..prefix.."resize"] == 2) then 
			_G["MMB"..prefix.."Timer"]:SetFont(filename,13.3*MMBfontscale, flags) 
			_G["MMB"..prefix.."resize"] = 0
		end

		elseif (MMBspellCD < 60) then
		
		_G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
		
		if (_G["MMB"..prefix.."resize"] == 1) then 
			_G["MMB"..prefix.."Timer"]:SetFont(filename,9.8*MMBfontscale, flags) 
			_G["MMB"..prefix.."resize"] = 2
		end
		
		elseif (MMBspellCD >= 60) then
		
		_G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%d:%0.2d|r",MMBspellCD / 60, MMBspellCD % 60))
		
		if (_G["MMB"..prefix.."resize"] == 0) then 
			_G["MMB"..prefix.."Timer"]:SetFont(filename,7.5*MMBfontscale, flags) 
			_G["MMB"..prefix.."resize"] = 1
		end
		end
		
		_G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
    
    elseif (duration > 1.55) and (MMBSettings[1])[13] == true and (MMBSettings[1])[18] == true then
    
        _G["MMB"..prefix]:Hide()

	else _G["MMB"..prefix.."Timer"]:SetText("")
        _G["MMB"..prefix]:Show()
	end
	
	if ((MMBSettings[1])[15] == true) and (duration < 1.55) then
		_G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.2,0.8,0.2,1,0.2,0.8,0.2,0)
	else _G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
	end

	if (spellId == 5405) and (GetItemCount(36799, false,true) == 0) then
		MMBmanaGemIcon:SetVertexColor(1,0,0,1)
        if ((MMBSettings[1])[15] == true) and (duration < 1.55) then
            MMBmanaGemgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
        end
	elseif (spellId == 5405) and (GetItemCount(36799, false,true) ~= 0) then
		MMBmanaGemIcon:SetVertexColor(1,1,1,1)
    end
	
end

function MMBmageArmorSpec()

	if (GetPrimaryTalentTree() ~= 1) and ((MMBSettings[10])[5] == false) then
		MMBmageArmor:Hide()
	elseif (GetPrimaryTalentTree() == 1) and ((MMBSettings[10])[2] == true) then
		MMBmageArmor:Show()
	elseif ((MMBSettings[10])[5] == true) and ((MMBSettings[10])[2] == true) then
		MMBmageArmor:Show()
	end
	
end        

local function MMBmagearmorupdate()

	MMBmageArmor:ClearAllPoints()
	if (MMBmageArmorIcon:GetTexture() == "Interface\\Icons\\Spell_Frost_FrostArmor02") then
		MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", ceil((MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+(MageManaBarOverflowFrame:GetWidth()*((102/100)-1))),0)
	else MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", ceil((MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+(MageManaBarOverflowFrame:GetWidth()*(((MMBSettings[10])[4]/100)-1))),0)
	end

end

local function MMBMageArmorType()

	if select(1,UnitAura("player",select(1,GetSpellInfo(7302)))) then
		if (select(4,GetGlyphSocketInfo(1)) == 98397) or (select(4,GetGlyphSocketInfo(4)) == 98397) or (select(4,GetGlyphSocketInfo(6)) == 98397) then 
            MMBmageArmorIcon:SetVertexColor(1,1,1,1)
            MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_Frost_FrostArmor02")
            MMBmagearmorupdate()
            if ((MMBSettings[1])[15] == true) then
                MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.2,0.8,0.2,0,0.2,0.8,0.2,1)
            else MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
            end
        else MMBmageArmorIcon:SetVertexColor(1,0,0,1)
            MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
            MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
		end
        if (MMBSettings[10])[6] == true and ((MMBSettings[10])[5] == true) and ((MMBSettings[10])[2] == true) and (GetPrimaryTalentTree() ~= 1) then 
            MMBmageArmor:Show()
        end
	elseif select(1,UnitAura("player",select(1,GetSpellInfo(6117)))) then
		MMBmageArmorIcon:SetVertexColor(1,1,1,1)
        MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
        if ((MMBSettings[1])[15] == true) then
            MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.2,0.8,0.2,0,0.2,0.8,0.2,1)
        else MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
		end
        if (MMBSettings[10])[6] == true and ((MMBSettings[10])[5] == true) and ((MMBSettings[10])[2] == true) and (GetPrimaryTalentTree() ~= 1) then 
            MMBmageArmor:Show()
        end
	else MMBmageArmorIcon:SetVertexColor(1,0,0,1)
        MMBmageArmorgradred:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,0,0.8,0.2,0.2,1)
        MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
        if (MMBSettings[10])[6] == true and (GetPrimaryTalentTree() ~= 1) then 
            MMBmageArmor:Hide()
        end
	end

    
end

local function MMBTimeToDie(unit) 

	local MMBhealth = UnitHealth("target")
	
	if MMBoldhealth ~= MMBhealth then

		MMBoldhealth = MMBhealth

		local text
		
		if MMBhealth == UnitHealthMax("target") then
			MMBhealth0, MMBtime0, MMBmhealth, MMBmtime = nil
			text = "--"
			return text
		end
	
		local MMBtime = GetTime()
	
		if not MMBhealth0 then
			MMBhealth0, MMBtime0 = MMBhealth, MMBtime
			MMBmhealth, MMBmtime = MMBhealth, MMBtime
			return
		end
	
		MMBmhealth = (MMBmhealth + MMBhealth) * .5
		MMBmtime = (MMBmtime + MMBtime) * .5
	
		if MMBmhealth >= MMBhealth0 then
			MMBhealth0, MMBtime0, MMBmhealth, MMBmtime = nil
			text = "Healing"
		else  
			MMBTimeToDIE = MMBhealth * (MMBtime0 - MMBmtime) / (MMBmhealth - MMBhealth0)
			if (MMBTimeToDIE <= 60) then
				text = format("%0.2d",MMBTimeToDIE)
			elseif (MMBTimeToDIE > 60) then
				text = format("%d:%0.2d",MMBTimeToDIE / 60, MMBTimeToDIE % 60)
			end
		end

		return text
		
	elseif unit == nil then
		
		return "--"
		
	end
	
end

local function MMBTimeToOom() 

	local MMBmana = UnitPower("player")
	
	if MMBoldmana ~= MMBmana then
		
		MMBoldmana = MMBmana

		local text
		
		if MMBmana == UnitPowerMax("player") then
			MMBmana0, MMBmanatime0, MMBmmana, MMBmanamtime = nil
			text = "--"
			return text
		end
	
		local MMBmanatime = GetTime()
	
		if not MMBmana0 then
			MMBmana0, MMBmanatime0 = MMBmana, MMBmanatime
			MMBmmana, MMBmanamtime = MMBmana, MMBmanatime
			return
		end
	
		MMBmmana = (MMBmmana + MMBmana) * .5
		MMBmanamtime = (MMBmanamtime + MMBmanatime) * .5
	
		if MMBmmana > MMBmana0 then
			MMBmana0, MMBmanatime0, MMBmmana, MMBmanamtime = nil
			text = "Regen"
		else  
			MMBTimeToOOM = MMBmana * (MMBmanatime0 - MMBmanamtime) / (MMBmmana - MMBmana0)
			if (MMBTimeToOOM <= 60) then
			text = format("%0.2d",MMBTimeToOOM)
			elseif (MMBTimeToOOM > 60) then
			text = format("%d:%0.2d",MMBTimeToOOM / 60, MMBTimeToOOM % 60)
			end
		end
		
		return text 
		
	end

end

local function MMBFramePositionCallback (frame, row, method)
--print("callback",frame, row, method)
	local MMBframeposition = 0
	
	for i = 1, #MMBSettings[20] do
	
		if (MMBSettings[20])[i] == frame then
			MMBframeposition =  1
			break
		else MMBframeposition = 0
		end

	end
	
	if method == "hide" and MMBframeposition == 1 then --print(frame,7,row)
		MMBFramePosition (frame,7,row)
	elseif method == "show" and MMBframeposition == 0 then --print(frame,#MMBSettings[20]+1,row)
		MMBFramePosition (frame,#MMBSettings[20]+1,row)	
	end
	
end

local function MMBWastedManaCollect(event)

	if event == "UNIT_POWER" then
	
		if UnitPower("player") > MMBregmanapool then
			MMBPower = UnitPower("player")
        elseif UnitPower("player") < MMBregmanapool then
			MMBPower = 0 
 		end
		
	elseif event == "UNIT_MAXPOWER" then
		
		MMBPowerMax = UnitPowerMax("player")
		
		if MMBPowerMax < MMBPower then
			MMBWastedMana = MMBPower - MMBPowerMax
			print(format("|cffff00ff -- You just wasted |cffffffff%.0f |cffff00ffmana --", MMBWastedMana))
			MMBTotalWastedMana = MMBTotalWastedMana + MMBWastedMana
			MMBWastedMana = 0
			MMBPower = 0
		end
		
	end
end

local function MMBCastBarUpdate()

    local text
    
    if MMBSpellCast["starttime"] and MMBSpellCast["starttime"] ~= 0 then
   -- print("castupdate")

        MMBCurrentCast = (GetTime() - (MMBSpellCast["starttime"]/1000))
        
        if MMBcasttype == "cast" then
            MageManaBarCastBar:SetValue(MMBCurrentCast)
            text = format("%.1f / %.1f", MMBCurrentCast, MMBSpellCast["duration"])
        elseif MMBcasttype == "channel" then
            MageManaBarCastBar:SetValue(MMBSpellCast["duration"] - MMBCurrentCast)
            text = format("%.1f / %.1f", MMBSpellCast["duration"] - MMBCurrentCast, MMBSpellCast["duration"])
        end
        
        if MMBCastTimeLost ~= 0 then
            text = format("|cffff0000+ %.2f |cffffffff%s", MMBCastTimeLost, text)
        end
        
        MageManaBarCastBarTimer:SetText(text)
        
    elseif (MMBSettings[21])[6] == true and MageManaBarCastFrame:IsShown() then 
--    print("hide cast")
            MageManaBarCastFrame:Hide()
            MMBAutohideManager("MageManaBarCastFrame","hide")

    end
	
end

local function MMBCastInfoStore()
--print("infostore")
    local name, nameSubtext, text, texture, startTime, endTime, isTradeSkill, castID, notInterruptible, casttext
            
    if UnitCastingInfo("player") or UnitChannelInfo("player") then
    	
   	    MageManaBarCastFrame:Show()
   	    
   	    if (MMBSettings[21])[6] == true then
        	MMBAutohideManager("MageManaBarCastFrame","show")
        end
        
   	    MageManaBarCastBar:SetAlpha(1)
    
        if UnitCastingInfo("player") then
            MMBcasttype = "cast"
            name, nameSubtext, text, texture, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitCastingInfo("player")
        elseif UnitChannelInfo("player") then
            MMBcasttype = "channel"
            name, nameSubtext, text, texture, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitChannelInfo("player")
        end
        
        MMBSpellCast["starttime"] =  startTime
        MMBSpellCast["duration"] = format("%.2f",(endTime - startTime) / 1000)

        MageManaBarCastBarIcon:SetTexture(texture)
        MageManaBarCastBar:SetMinMaxValues(0, MMBSpellCast["duration"])
        
        if nameSubtext ~= "" then 
            casttext = (name.." - "..nameSubtext)
        else casttext = name
        end
        
        if (MMBSettings[21])[4] == true and MMBCastTarget and MMBCastTarget ~= "" then
            casttext = (casttext.." --> ".. MMBCastTarget )
        end
        
        MageManaBarCastBarText:SetText(casttext)
        
        if MMBcasttype == "cast" then
            MageManaBarCastBar:SetStatusBarColor(unpack((MMBSettings[21])[7]))
        elseif MMBcasttype == "channel" then
            MageManaBarCastBar:SetStatusBarColor(unpack((MMBSettings[21])[8]))
        end

    end

end

local MMBInfoFunction = { "Health related",

					function() if UnitIsDead("player") then	return "Dead" elseif UnitIsGhost("player") then	return "Ghost" end return MMBNumberConvert(UnitHealth("player")) end, -- Current Health
		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" end return UnitHealth("player") end, -- Absolute Current HP
		    		function() return MMBNumberConvert(UnitHealthMax("player")) end, -- Max HP

		    		function() return UnitHealthMax("player") end, -- Absolute Max HP

		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" end return format("%s/%s", MMBNumberConvert(UnitHealth("player")), MMBNumberConvert(UnitHealthMax("player"))) end, --Cur/Max HP
		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" end return format("%s/%s", UnitHealth("player"), UnitHealthMax("player")) end, -- Absolute Cur/Max HP

		    		function() if UnitIsDead("player") then return "Dead" elseif UnitIsGhost("player") then return "Ghost" elseif (UnitHealthMax("player") - UnitHealth("player")) <= 0 then return "--" else return MMBNumberConvert(UnitHealthMax("player") - UnitHealth("player")) end end, -- Missing HP

		    		function() if UnitHealthMax("player") <= 0 or UnitIsDead("player") or UnitIsGhost("player") then return "0%" end return format("%.1f%%",UnitHealth("player") / UnitHealthMax("player") * 100) end, -- Percent Hp

		    		0,

		    		
		    		"Mana related",

		    		function() if UnitIsDeadOrGhost("player") then return 0 end return MMBNumberConvert(UnitPower("player")) end, -- Current Power
		    		function() if UnitIsDeadOrGhost("player") then return 0 end	return UnitPower("player") end, -- Absolute Current power

		    		function() return MMBNumberConvert(UnitPowerMax("player")) end, -- Max power

		    		function() return UnitPowerMax("player") end, -- Absolute max power
		    		function() return format("%s/%s", MMBNumberConvert(UnitPower("player")), MMBNumberConvert(UnitPowerMax("player"))) end, -- Cur/Max Power

		    		function() return format("%s/%.1f%%", MMBNumberConvert(UnitPower("player")), UnitPower("player") / MMBregmanapool * 100) end, -- Cur/% Power

		    		function() return format("%s/%s", MMBNumberConvert(MMBregmanapool), MMBNumberConvert(UnitPowerMax("player"))) end, -- regular Max power/Max Power

		    		function() return format("%s/%s", UnitPower("player"), UnitPowerMax("player")) end, -- Absolute Cur/Max power

		    		function() if (UnitPowerMax("player") - UnitPower("player")) > 0 then return MMBNumberConvert(UnitPowerMax("player") - UnitPower("player")) else return "--" end end, -- Missing power
		    		function() if UnitIsDeadOrGhost("player") then return "0%" end return format("%.1f%%", UnitPower("player") / MMBregmanapool * 100) end, -- Percent power
	
		    		0,

		    		0,
		    		
		    		"Miscellanous",
		    		function() return MMBTimeToOom() end,

		    		function() return MMBTimeToDie(UnitName("target")) end,
		    		function() if (GetPrimaryTalentTree() == 1) then return format("+%.1f%%", (1.5 * GetMastery()) * (UnitPower("player")/UnitPowerMax("player"))) elseif (GetPrimaryTalentTree() == 2) then return format("+%.1f%%", 2.8 * GetMastery()) elseif (GetPrimaryTalentTree() == 3) then return format("+%.1f%%", 2.5 * GetMastery()) end end,
                    function() if (GetPrimaryTalentTree() == 1) then return GetSpellBonusDamage(7) elseif (GetPrimaryTalentTree() == 2) then return GetSpellBonusDamage(3) elseif (GetPrimaryTalentTree() == 3) then return GetSpellBonusDamage(5) end end,
                    } 

local function MMBmanaInfoUpdate()
	
	for i = 2,7 do
	
		local text = MMBInfoFunction[(MMBSettings[i])[12]]()
		
 		if text then
			if (MMBSettings[i])[11] == true then 
				_G["MMBInfoFrame"..(i-1).."Text"]:SetText(MMBInfoFunctionPrefix[(MMBSettings[i])[12]]..text)
			else _G["MMBInfoFrame"..(i-1).."Text"]:SetText(text)
			end
		end
	end

end

local function MMBGlobalFrameHeight()
    
    local MMBglobalheight = 0
    
    for i = 1,#MMBSettings[20] do 
        MMBglobalheight = MMBglobalheight + _G[(MMBSettings[20])[i]]:GetHeight()
    end
    
    return MMBglobalheight

end

local function MMBEventsManager(frame,method)
	
    if MMBFrameEvents[frame] then
        if method == "unregister" then 
            for i = 1,#MMBFrameEvents[frame] do
                MageManaBarGlobal:UnregisterEvent((MMBFrameEvents[frame])[i])
--                print("unregister",(MMBFrameEvents[frame])[i])
            end
        elseif method == "register" then
            for i = 1,#MMBFrameEvents[frame] do
                MageManaBarGlobal:RegisterEvent((MMBFrameEvents[frame])[i])
--                print("register",(MMBFrameEvents[frame])[i])
            end
        end
    end
	
end

local function MMBFontTextureCheck(method,table,row,col)

	if select(2, UnitClass("player")) == "MAGE" then 
	
		if method == "font" then
			
			if not MMBLSM:HashTable("font")[(table[row])[col]] then
				print( 'MageManaBar : font "', (table[row])[col], '" is not available, it will be replaced by its default.');
				--(table[row])[col] = "Friz Quadrata TT"
				--(table[row])[col-1] = MMBLSM:HashTable("font")["Friz Quadrata TT"]
				MMBErrorSettings = MMBErrorSettings + 1
			end
		
		elseif method == "statusbar" then
		
			if not MMBLSM:HashTable("statusbar")[(table[row])[col]] then
				print( 'MageManaBar : texture "', (table[row])[col], '" is not available, it will be replaced by its default.');
				--(table[row])[col] = "CombuBar"
				--(table[row])[col-1] = MMBLSM:HashTable("statusbar")["CombuBar"]
				MMBErrorSettings = MMBErrorSettings + 1
			end
				
		end
	end

end

local function MMBSettingsCheck (table)

	MMBErrorSettings = 0
	
	MMBFontTextureCheck("statusbar",table,15,9) -- check mana bar texture
	MMBFontTextureCheck("font",table,15,11) -- check mana bar font
	MMBFontTextureCheck("statusbar",table,17,9) -- check warning bar texture
	MMBFontTextureCheck("font",table,17,11) -- check warning bar font
	MMBFontTextureCheck("statusbar",table,19,7) -- check health bar texture
	MMBFontTextureCheck("statusbar",table,21,11) -- check cast bar texture
	MMBFontTextureCheck("font",table,21,13) -- check cast bar font
	MMBFontTextureCheck("statusbar",table,22,6) -- check Alt bar texture
	MMBFontTextureCheck("font",table,22,8)	 -- check Alt bar font
    
	if MMBErrorSettings > 0 then
		print("-- MageManaBar :",MMBErrorSettings,"settings for fonts/textures were invalid and replaced by defaults. --")
	end

end

function MMBInfoFrameReset(...)

	for i = 1,select("#", ...) do
		for z = 1,#MMBBaseSettings[select(i, ...)] do
			if type((MMBBaseSettings[select(i, ...)])[z]) == "table" then
				for x = 1,#(MMBBaseSettings[select(i, ...)])[z] do
					((MMBSettings[select(i, ...)])[z])[x] = ((MMBBaseSettings[select(i, ...)])[z])[x]
				end
			else (MMBSettings[select(i, ...)])[z] = (MMBBaseSettings[select(i, ...)])[z]
			end
		end
		if _G[(MMBSettings[select(i, ...)])[1]] and _G[(MMBSettings[select(i, ...)])[1]]:IsUserPlaced() then
			_G[(MMBSettings[select(i, ...)])[1]]:SetUserPlaced(nil)
		end
	end

	MMBFrameResize()
	InterfaceOptionsFramePanelContainer:Hide()
	InterfaceOptionsFramePanelContainer:Show()
	
end

function MMBAutohide()

	if ((MMBSettings[1])[12] == 1) and ((MMBSettings[1])[16] == true) then
		MageManaBarGlobal:Show()
	elseif ((MMBSettings[1])[12] == 2) then
		if UnitAffectingCombat("player") and ((MMBSettings[1])[16] == true) then
			MageManaBarGlobal:Show()
		else MageManaBarGlobal:Hide()
		end
	elseif ((MMBSettings[1])[12] == 3) then
		if (GetPrimaryTalentTree() == 1) and ((MMBSettings[1])[16] == true) then
			MageManaBarGlobal:Show()
		else MageManaBarGlobal:Hide()
		end
	elseif ((MMBSettings[1])[12] == 4) then
		if UnitAffectingCombat("player") and (GetPrimaryTalentTree() == 1) and ((MMBSettings[1])[16] == true) then
			MageManaBarGlobal:Show()
		else MageManaBarGlobal:Hide()
		end
	end
	
end

function MMBCreateTextureList(frame,row,col,colourcol)

	MMBTextureList = {} for k in pairs(MMBLSM:HashTable("statusbar")) do tinsert(MMBTextureList,k) end
	
	MMBTextureBorderFrame:Show()
	MMBTextureBorderFrame:ClearAllPoints()
	MMBTextureFrame:SetHeight(#MMBTextureList*20)
	MMBTextureBorderFrame:SetPoint("CENTER",frame,"CENTER",0,0-(MMBTextureBorderFrame:GetHeight()/4))
	MMBTextureBorderFrame:SetParent(InterfaceOptionsFrame)
	MMBTextureBorderFrame:SetFrameLevel(_G[frame:GetName().."Button"]:GetFrameLevel()+1)
	MMBTextureBorderFrame:SetScale(1.3)
	MMBTextureRow = row
	MMBTextureCol = col
	MMBTextureDDown = frame
	
	for i = 1,#MMBTextureList do
		
		if not _G["MMBTexture"..i] then
			CreateFrame("button", "MMBTexture"..i, MMBTextureFrame, "MMBTextureTemplate")
		end
		
		if i == 1 then
			MMBTexture1:ClearAllPoints()
			MMBTexture1:SetPoint("TOP",MMBTextureFrame,"TOP",0,0)
		else _G["MMBTexture"..i]:ClearAllPoints()
			_G["MMBTexture"..i]:SetPoint("TOP",_G["MMBTexture"..i-1],"BOTTOM",0,0)
		end
		
		_G["MMBTexture"..i.."Bar"]:SetTexture(MMBLSM:Fetch("statusbar",MMBTextureList[i]))
		_G["MMBTexture"..i.."Bar"]:SetVertexColor(unpack((MMBSettings[row])[colourcol]))
		_G["MMBTexture"..i.."Text"]:SetText(MMBTextureList[i])
		
		if MMBTextureList[i] == (MMBSettings[row])[col+1] then
			_G["MMBTexture"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
		else _G["MMBTexture"..i.."Text"]:SetTextColor(1,1,1,1)
		end
	
	end
	
end
		
function MMBCreateFontList(frame,row,col,colourcol)

	MMBFontList = {} for k in pairs(MMBLSM:HashTable("font")) do tinsert(MMBFontList,k) end
	
	MMBFontBorderFrame:Show()
	MMBFontBorderFrame:ClearAllPoints()
	MMBFontFrame:SetHeight(#MMBFontList*15)
	MMBFontBorderFrame:SetPoint("CENTER",frame,"CENTER",0,0-(MMBFontBorderFrame:GetHeight()/4))
	MMBFontBorderFrame:SetParent(InterfaceOptionsFrame)
	MMBFontBorderFrame:SetFrameLevel(_G[frame:GetName().."Button"]:GetFrameLevel()+1)
	MMBFontBorderFrame:SetScale(1.3)
	MMBFontRow = row
	MMBFontCol = col
	MMBFontDDown = frame
	
	for i = 1,#MMBFontList do
	
		if not _G["MMBFont"..i] then
			CreateFrame("button", "MMBFont"..i, MMBFontFrame, "MMBFontTemplate")
		end
		
		if i == 1 then
		MMBFont1:ClearAllPoints()
		MMBFont1:SetPoint("TOP",MMBFontFrame,"TOP",0,0)
		else _G["MMBFont"..i]:ClearAllPoints()
			_G["MMBFont"..i]:SetPoint("TOP",_G["MMBFont"..i-1],"BOTTOM",0,0)
		end
		
		_G["MMBFont"..i.."Bar"]:SetTexture(MMBLSM:Fetch("statusbar",(MMBSettings[row])[col-2]))
		_G["MMBFont"..i.."Bar"]:SetVertexColor(unpack((MMBSettings[row])[colourcol]))
		_G["MMBFont"..i.."Text"]:SetText(MMBFontList[i])
		_G["MMBFont"..i.."Text"]:SetFont(MMBLSM:Fetch("font",MMBFontList[i]),9)
		
		if MMBFontList[i] == (MMBSettings[row])[col] then
			_G["MMBFont"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
		else _G["MMBFont"..i.."Text"]:SetTextColor(1,1,1,1)
		end
	
	end
	
end

function MMBInfoTag()

	MMBInfoTagFrame:Show()
	MMBInfoTagFrame:SetScale(1.2)
    MMBInfoTagFrame:SetFrameStrata("HIGH")
	MMBInfoTagFrame:SetFrameLevel(_G["MMBTagSetup"..(MMBTagRow-1)]:GetFrameLevel()+1)
	MMBInfoTagFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)

	if not MMBTagButton1 then
	
		for i = 1, #MMBInfoFunction do
			CreateFrame("button", "MMBTagButton"..i, MMBInfoTagFrame, "MMBInfoTagButtonTemplate")

			_G["MMBTagButton"..i]:SetID(i)
			
			if i == 1 then
				_G["MMBTagButton"..i]:ClearAllPoints()

				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",MMBInfoTagFrame,"TOPLEFT",5,-5)
				MMBTagBuild = 0

			elseif type(MMBInfoFunction[i-1]) == "string" then

				_G["MMBTagButton"..i]:ClearAllPoints()

				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",_G["MMBTagButton"..i-1],"BOTTOMLEFT",0,-5)
				MMBTagBuild = 1

			elseif MMBTagBuild == 3 then
				_G["MMBTagButton"..i]:ClearAllPoints()
				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",_G["MMBTagButton"..i-3],"BOTTOMLEFT",0,-5)
				MMBTagBuild = 1
			elseif MMBTagBuild == 1 or MMBTagBuild == 2 then
				_G["MMBTagButton"..i]:ClearAllPoints()

				_G["MMBTagButton"..i]:SetPoint("TOPLEFT",_G["MMBTagButton"..i-1],"TOPRIGHT",5,0)

				MMBTagBuild = MMBTagBuild + 1
			end

		end
	end
	
	for i = 1, #MMBInfoFunction do
		if type(MMBInfoFunction[i]) == "string" then
			_G["MMBTagButton"..i.."Value"]:SetText("")
			_G["MMBTagButton"..i.."Text"]:SetWidth(200)
			_G["MMBTagButton"..i.."Text"]:SetText(MMBInfoFunction[i])
			_G["MMBTagButton"..i.."Text"]:SetFont("Fonts\\FRIZQT__.TTF",10)

			_G["MMBTagButton"..i.."Text"]:SetJustifyH("LEFT")
			_G["MMBTagButton"..i.."Text"]:SetJustifyV("BOTTOM")
			_G["MMBTagButton"..i.."Bg"]:Hide()
			_G["MMBTagButton"..i]:EnableMouse(false)
		elseif (MMBInfoFunction[i]) == 0 then
			_G["MMBTagButton"..i]:Hide()
			_G["MMBTagButton"..i]:EnableMouse(false)
		else _G["MMBTagButton"..i.."Text"]:SetText(MMBInfoFunctionText[i])
			_G["MMBTagButton"..i.."Value"]:SetText(MMBInfoFunction[i]())

			_G["MMBTagButton"..i.."Value"]:SetFont((MMBSettings[15])[10],9)
			_G["MMBTagButton"..i.."Value"]:SetJustifyH("CENTER")

			_G["MMBTagButton"..i.."Value"]:SetJustifyV("MIDDLE")

			_G["MMBTagButton"..i.."Bg"]:Show()
		end

	end

end
		
function MMBFramePosition (frame,position,row)
--print("frameposition")
	for i = #MMBSettings[20],1,-1 do -- this part clean the frame list by removing the called frame from it

        if frame and (MMBSettings[20])[i] == frame then
			table.remove(MMBSettings[20],i)
--			break
		end
	end
	
	if position and position ~= 7 then -- this part insert the called frame in the list at the needed position and callback the enable settings in Savedvariable table
		(MMBSettings[row])[2] = true
		if position > #MMBSettings[20] then 
			table.insert(MMBSettings[20],#MMBSettings[20]+1,frame)
		else table.insert(MMBSettings[20],position,frame)
		end
	elseif position == 7 then
		(MMBSettings[row])[2] = false
--		table.insert(MMBSettings[20],frame)
	end
	
	if #MMBSettings[20] >= 1 then -- this part redo all the positionning depending on the new frame list
		
		for i = 1, #MMBpositionDDown do
		
			_G[(MMBpositionDDown[i])[2]]:ClearAllPoints()
			
		end
		
		for i = 1, #MMBSettings[20] do
			
			if i == 1 then
		--		_G[(MMBSettings[20])[i]]:ClearAllPoints()
				_G[(MMBSettings[20])[i]]:SetPoint("TOP", MageManaBarGlobal, "TOP", 0,0)
			else --_G[(MMBSettings[20])[i]]:ClearAllPoints()
				_G[(MMBSettings[20])[i]]:SetPoint("TOP", _G[(MMBSettings[20])[i-1]], "BOTTOM", 0,0)
			end
		end
	end

	for i = 1, #MMBpositionDDown do -- this part actualize the dropdowns and hide/show the frame
	
		for x = 1, #MMBSettings[20] do
		
			if (MMBpositionDDown[i])[2] == (MMBSettings[20])[x] then
				UIDropDownMenu_SetSelectedID(_G[(MMBpositionDDown[i])[1]], x)
				UIDropDownMenu_SetText(_G[(MMBpositionDDown[i])[1]], MMBpositionList[x])
				_G[(MMBpositionDDown[i])[2]]:Show()
                MMBEventsManager((MMBpositionDDown[i])[2],"register")
                break
			else UIDropDownMenu_SetSelectedID(_G[(MMBpositionDDown[i])[1]], 7)
				UIDropDownMenu_SetText(_G[(MMBpositionDDown[i])[1]], MMBpositionList[7])
				_G[(MMBpositionDDown[i])[2]]:Hide()
                MMBEventsManager((MMBpositionDDown[i])[2],"unregister")
			end
		end
	end
    
    MMBGlobalAutohideCheck()
		
end

function MMBFrameResize()

--print("frameresize")
	if select(2, UnitClass("player")) ~= "MAGE" then 
        MageManaBarGlobal:Hide() 
        MageManaBarGlobal:SetScript("OnUpdate", nil)
        return 
    end

	MMBNewSettingsCheck()
    MMBSettingsCheck(MMBSettings)
   	MMBFramePosition ()
    
	-- Settings for warning Frame -------------------------------------------------
	if ((MMBSettings[17])[2] == true) then
		MMBFramePositionCallback("MageManaBarWarning",17,"show")
	else MMBFramePositionCallback("MageManaBarWarning",17,"hide")
	end

    MageManaBarWarning:SetHeight((MMBSettings[17])[6])
	MageManaBarWarningBg2:SetHeight((MMBSettings[17])[6]-3)
	MageManaBarWarningBar:SetHeight((MMBSettings[17])[6]-3)
	MageManaBarWarningBar2:SetHeight((MMBSettings[17])[6]-3)
	MageManaBarWarning:SetWidth((MMBSettings[17])[5])
	MageManaBarWarningBg2:SetWidth((MMBSettings[17])[5]-4)
	MageManaBarWarningBar:SetWidth((MMBSettings[17])[5]-4)
	MageManaBarWarningBar2:SetWidth((MMBSettings[17])[5]-4)
	MageManaBarWarningText:SetWidth((MMBSettings[17])[5]-4)
	MageManaBarWarningBar:SetStatusBarColor(unpack((MMBSettings[17])[7]))
	MageManaBarWarningBar2:SetStatusBarColor(1,0.5,0.8,0.5)
	MageManaBarWarningBar:SetStatusBarTexture(MMBLSM:Fetch("statusbar",(MMBSettings[17])[9]))
	MageManaBarWarningBar2:SetStatusBarTexture(MMBLSM:Fetch("statusbar",(MMBSettings[17])[9]))
	MageManaBarWarningBg:SetVertexColor(unpack((MMBSettings[17])[14]))
	MageManaBarWarningBg2:SetVertexColor(unpack((MMBSettings[17])[16]))
	MageManaBarWarningText:SetFont(MMBLSM:Fetch("font",(MMBSettings[17])[11]),(MMBSettings[17])[12])
    MageManaBarWarningBar2:SetFrameLevel(MageManaBarWarningBar:GetFrameLevel()+1)
    MageManaBarWarningTextFrame:SetFrameLevel(MageManaBarWarningBar2:GetFrameLevel()+1)
    
	if ((MMBSettings[17])[13] == true) then 
		MageManaBarWarningBg:Show()
	else MageManaBarWarningBg:Hide()
	end
    
	if ((MMBSettings[17])[15] == true) then 
		MageManaBarWarningBg2:Show()
	else MageManaBarWarningBg2:Hide()
	end

	-- Settings for Health bar  -------------------------------------------------
	if ((MMBSettings[19])[2] == true) then
		MMBFramePositionCallback("MageManaBarHealth",19,"show")
	else MMBFramePositionCallback("MageManaBarHealth",19,"hide")
	end
    
	MageManaBarHealth:SetHeight((MMBSettings[19])[4])
	MageManaBarHealthBg2:SetHeight((MMBSettings[19])[4]-2)
	MageManaBarHealth:SetWidth((MMBSettings[1])[5])
	MageManaBarHealthBg2:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarHealthBar:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarHealthBar:SetHeight((MMBSettings[19])[4]-2)
	MageManaBarHealthBar:SetStatusBarColor(unpack((MMBSettings[19])[5]))
	MageManaBarHealthBar:SetStatusBarTexture(MMBLSM:Fetch("statusbar",(MMBSettings[19])[7]))
	if ((MMBSettings[1])[8] == true) then 
		MageManaBarHealthBg:Show()
		MageManaBarHealthBg2:Show()
		MageManaBarHealthBg:SetVertexColor(unpack((MMBSettings[1])[7]))
	else MageManaBarHealthBg:Hide()
		MageManaBarHealthBg2:Hide()
	end
		
	-- Settings for Mana frame -----------------------------------------
	if ((MMBSettings[1])[2] == true) then
		MMBFramePositionCallback("MageManaBarBgFrame",1,"show")
	else MMBFramePositionCallback("MageManaBarBgFrame",1,"hide")
	end
    
	MageManaBarBgFrame:SetWidth((MMBSettings[1])[5])
	MageManaBarBgFrameBg2:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarBgFrame:SetHeight((MMBSettings[1])[6])
	MageManaBarBgFrameBg2:SetHeight((MMBSettings[1])[6]-2)
	MageManaBarBgFrameTexture:SetVertexColor(unpack((MMBSettings[1])[7]))
	if ((MMBSettings[1])[8] == true) then
		MageManaBarBgFrameTexture:Show()
		MageManaBarBgFrameBg2:Show()
	else MageManaBarBgFrameTexture:Hide()
		MageManaBarBgFrameBg2:Hide()
	end

	MageManaBarOverflowFrame:SetStatusBarColor(unpack((MMBSettings[16])[7]))
	MageManaBarOverflowFrame:SetStatusBarTexture(MMBLSM:Fetch("statusbar",(MMBSettings[15])[9]))
	MageManaBarOverflowFrame:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarOverflowFrame:SetHeight((MMBSettings[1])[6]-2)
	
	MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[7]))
	MageManaBarFrame:SetStatusBarTexture(MMBLSM:Fetch("statusbar",(MMBSettings[15])[9]))
	MageManaBarFrame:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarFrame:SetHeight((MMBSettings[1])[6]-2)
	
	-- Settings for Alternate bar  -------------------------------------------------
	if ((MMBSettings[22])[2] == true) then
		MMBFramePositionCallback("MageManaBarAlternate",22,"show")
	else MMBFramePositionCallback("MageManaBarAlternate",22,"hide")
	end
        
	MageManaBarAlternate:SetHeight((MMBSettings[22])[3])
	MageManaBarAlternateBg2:SetHeight((MMBSettings[22])[3]-2)
	MageManaBarAlternate:SetWidth((MMBSettings[1])[5])
	MageManaBarAlternateBg2:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarAlternateBar:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarAlternateText:SetWidth((MMBSettings[1])[5]-2)
	MageManaBarAlternateBar:SetHeight((MMBSettings[22])[3]-2)
	MageManaBarAlternateText:SetHeight((MMBSettings[22])[3]-2)
	MageManaBarAlternateBar:SetStatusBarColor(unpack((MMBSettings[22])[4]))
	MageManaBarAlternateBar:SetStatusBarTexture(MMBLSM:Fetch("statusbar",(MMBSettings[22])[6]))
	MageManaBarAlternateText:SetFont(MMBLSM:Fetch("font",(MMBSettings[22])[8]),(MMBSettings[22])[9])
	if ((MMBSettings[1])[8] == true) then 
		MageManaBarAlternateBg:Show()
		MageManaBarAlternateBg2:Show()
		MageManaBarAlternateBg:SetVertexColor(unpack((MMBSettings[1])[7]))
	else MageManaBarAlternateBg:Hide()
		MageManaBarAlternateBg2:Hide()
	end
		
	-- settings for cast bar frame ------------------------------------------------
	if ((MMBSettings[21])[2] == true) then
		MMBFramePositionCallback("MageManaBarCastFrame",21,"show")
	else MMBFramePositionCallback("MageManaBarCastFrame",21,"hide")
    end
	
	MageManaBarCastFrame:SetWidth((MMBSettings[1])[5])
	MageManaBarCastFrame:SetHeight((MMBSettings[21])[5])
	MageManaBarCastBar:SetHeight((MMBSettings[21])[5]-2)
	MageManaBarCastBar:SetStatusBarColor(unpack((MMBSettings[21])[7]))
	MageManaBarCastBar:SetStatusBarTexture(MMBLSM:Fetch("statusbar",(MMBSettings[21])[11]))
	MageManaBarCastFrameTexture:SetVertexColor(unpack((MMBSettings[1])[7]))
	MageManaBarCastBarText:SetFont(MMBLSM:Fetch("font",(MMBSettings[21])[13]),(MMBSettings[21])[14])
	MageManaBarCastBarText:SetHeight((MMBSettings[21])[5]-2)
	MageManaBarCastBarTimer:SetFont(MMBLSM:Fetch("font",(MMBSettings[21])[13]),(MMBSettings[21])[14])
	MageManaBarCastBarTimer:SetHeight((MMBSettings[21])[5]-2)
	MageManaBarCastBarTimer:SetWidth((MMBSettings[1])[5]*0.25)
	MageManaBarCastBarIcon:SetHeight((MMBSettings[21])[5]-2)
	MageManaBarCastBarIcon:SetWidth((MMBSettings[21])[5]-2)

	if ((MMBSettings[21])[3] == true) then
		MageManaBarCastBarIcon:Show()
		MageManaBarCastBar:SetWidth((MMBSettings[1])[5]-2-(MMBSettings[21])[5]-1+2)
		MageManaBarCastBarText:SetWidth((MMBSettings[1])[5]-2-(MMBSettings[21])[5]-2-((MMBSettings[1])[5]*0.25))
	else MageManaBarCastBarIcon:Hide()
		MageManaBarCastBar:SetWidth((MMBSettings[1])[5]-2)
		MageManaBarCastBarText:SetWidth((MMBSettings[1])[5]-2-(((MMBSettings[21])[5]+2)*4))
	end
	
	-- settings for info frames ------------------------------------------------
	for i = 2,7 do
		_G[(MMBSettings[i])[1].."Text"]:SetFont(MMBLSM:Fetch("font",(MMBSettings[15])[11]),(MMBSettings[i])[4])
		_G[(MMBSettings[i])[1]]:EnableMouse((MMBSettings[i])[3]);
		_G[(MMBSettings[i])[1]]:SetWidth((MMBSettings[i])[5]);
		_G[(MMBSettings[i])[1]]:SetHeight((MMBSettings[i])[6]);
		_G[(MMBSettings[i])[1].."Texture"]:SetVertexColor(unpack((MMBSettings[i])[7]))
		if ((MMBSettings[i])[8] == true) then
			_G[(MMBSettings[i])[1].."Texture"]:Show()
		else _G[(MMBSettings[i])[1].."Texture"]:Hide()
		end
		if ((MMBSettings[i])[2] == true) then
			_G[(MMBSettings[i])[1]]:Show()
		else _G[(MMBSettings[i])[1]]:Hide()
		end
	end
	
	if ((MMBSettings[13])[3] == true) then 
        MageManaBarInfoFrameTexture:Show()
	else MageManaBarInfoFrameTexture:Hide()
	end
	
	if ((MMBSettings[13])[2] == true) then
		MMBFramePositionCallback("MageManaBarInfoFrame",13,"show")
	else MMBFramePositionCallback("MageManaBarInfoFrame",13,"hide")
	end

	MageManaBarInfoFrameTexture:SetVertexColor(unpack((MMBSettings[13])[7]))
	MageManaBarInfoFrame:SetHeight((MMBSettings[13])[4])
	MageManaBarInfoFrame:SetWidth((MMBSettings[1])[5])
    MageManaBarInfoFrame:SetFrameLevel(MageManaBarGlobal:GetFrameLevel() + 10)
	
	-- settings for mana markers icons --------------------------------------------
	for i = 8,12 do 
        if ((MMBSettings[i])[2] == true) then
            _G[(MMBSettings[i])[1]]:Show()
        else _G[(MMBSettings[i])[1]]:Hide()
        end
        if ((MMBSettings[i])[3] == true) then
            _G[(MMBSettings[i])[1].."Icon"]:Show()
            _G[(MMBSettings[i])[1].."Frame"]:Show()
            if _G[(MMBSettings[i])[1].."Text"] then
                _G[(MMBSettings[i])[1].."Text"]:Show()
            end
        else _G[(MMBSettings[i])[1].."Icon"]:Hide()
             _G[(MMBSettings[i])[1].."Frame"]:Hide()
             if _G[(MMBSettings[i])[1].."Text"] then
                _G[(MMBSettings[i])[1].."Text"]:Hide()
             end
        end
	end

	if ((MMBSettings[1])[13] == true) then 
        MMBmanaGemTextFrame:Show()
        MMBevocationTextFrame:Show()
        MMBArcaneTorrentTextFrame:Show()
        MMBOrbTextFrame:Show()
	else MMBmanaGemTextFrame:Hide()
		MMBevocationTextFrame:Hide()
		MMBArcaneTorrentTextFrame:Hide()
		MMBOrbTextFrame:Hide()
	end

	for i = 1,#MMBprefixtable do -- adjust height of markers gradients
		
		_G["MMB"..MMBprefixtable[i]]:SetHeight((MMBSettings[1])[6]-2)
		_G["MMB"..MMBprefixtable[i].."gradred"]:SetHeight((MMBSettings[1])[6]-2)
		_G["MMB"..MMBprefixtable[i].."gradblack"]:SetHeight((MMBSettings[1])[6]-2)
		_G["MMB"..MMBprefixtable[i].."gradFrame"]:SetHeight((MMBSettings[1])[6]-2)
	end
	
	-- Settings for expected spell mana cost ---------------------------------------
	if ((MMBSettings[14])[2] == true) then
        MMBspellcost:Show()
		MMBspellcost:SetHeight((MMBSettings[1])[6]-2)
		MMBspellcost:SetAlpha((MMBSettings[14])[3])
	else MMBspellcost:Hide()
	end
	    
	-- Settings for Global Frame ----------------------------------------------
	if ((MMBSettings[1])[16] == true) then
		MageManaBarGlobal:Show()
		MageManaBarGlobal:SetWidth((MMBSettings[1])[5])
		MageManaBarGlobal:SetHeight(MMBGlobalFrameHeight())
		MageManaBarGlobal:SetAlpha((MMBSettings[1])[10])
		MageManaBarGlobal:SetFrameLevel((MMBSettings[1])[9])
		MageManaBarGlobal:SetScale((MMBSettings[1])[4])
        MageManaBarGlobal:SetFrameStrata(MMBFrameStrata[(MMBSettings[1])[19]])
        MageManaBarGlobal:EnableMouse((MMBSettings[1])[21])
		if (MMBSettings[1])[3] == true then
            MageManaBarGlobal:RegisterForDrag("LeftButton")
        else MageManaBarGlobal:RegisterForDrag()
        end
	else MageManaBarGlobal:Hide()
	end
    
	-- Added functions -------------------------------------------------------------
	MMBManabarMaxPool()
	MMBmageArmorSpec()
	MMBmagearmorupdate()
    MMBInfoFramesResize()
   	MMBAutohide()

end

function MMBSavedVariablesExport()

	MMBSavedVariablesDump = select(1,GetAddOnMetadata("MageManaBar", "Version")).."-mage"
	
	for i = 1,#MMBSettings do
		
		MMBSavedVariablesDump = MMBSavedVariablesDump .. "X{"
		
		for z = 1,#MMBSettings[i] do
		
			if z == #MMBSettings[i] then
				
				if (MMBSettings[i])[z] == true then
  
					MMBSavedVariablesDump = MMBSavedVariablesDump .."true".."}"

				elseif (MMBSettings[i])[z] == false then
				
					MMBSavedVariablesDump = MMBSavedVariablesDump .."false".."}"
					
				elseif type((MMBSettings[i])[z]) == "table" then
	
					MMBSavedVariablesDump = MMBSavedVariablesDump .. "{"
	
					for x = 1,#(MMBBaseSettings[i])[z] do
						
						if x == #(MMBBaseSettings[i])[z] then
							MMBSavedVariablesDump = MMBSavedVariablesDump ..((MMBSettings[i])[z])[x].."}}" 
						else MMBSavedVariablesDump = MMBSavedVariablesDump ..((MMBSettings[i])[z])[x]..","
						end
						
					end
					
				else if type((MMBSettings[i])[z]) == "string" then 
						MMBSavedVariablesDump = MMBSavedVariablesDump .."'"..(MMBSettings[i])[z].."'".."}"
					else MMBSavedVariablesDump = MMBSavedVariablesDump ..(MMBSettings[i])[z].."}"
					end
				end
						
			elseif type((MMBSettings[i])[z]) == "table" then

				MMBSavedVariablesDump = MMBSavedVariablesDump .. "{"

				for x = 1,#(MMBBaseSettings[i])[z] do
					
					if x == #(MMBBaseSettings[i])[z] then
						MMBSavedVariablesDump = MMBSavedVariablesDump ..((MMBSettings[i])[z])[x].."}," 
					else MMBSavedVariablesDump = MMBSavedVariablesDump ..((MMBSettings[i])[z])[x]..","
					end
					
				end
			
			elseif (MMBSettings[i])[z] == true then
  
				MMBSavedVariablesDump = MMBSavedVariablesDump .."true"..","

			elseif (MMBSettings[i])[z] == false then
  
				MMBSavedVariablesDump = MMBSavedVariablesDump .."false"..","
				
			else if type((MMBSettings[i])[z]) == "string" then 
					MMBSavedVariablesDump = MMBSavedVariablesDump .."'"..(MMBSettings[i])[z].."'"..","
				else MMBSavedVariablesDump = MMBSavedVariablesDump ..(MMBSettings[i])[z]..","
				end
			
            end
		end
		
	end
		
	MMBSavedVariablesDump = string.gsub(MMBSavedVariablesDump,"\\","\\\\")
	
	return MMBSavedVariablesDump
	
end

function MMBSavedvariablesImport()

	if MMBimportexportBox:GetText() ~= "" then
    
    	MMBimport1, MMBimport2, MMBimport3, MMBimport4, MMBimport5, MMBimport6, MMBimport7, MMBimport8, MMBimport9, MMBimport10, MMBimport11, MMBimport12, MMBimport13, MMBimport14, MMBimport15, MMBimport16, MMBimport17, MMBimport18, MMBimport19, MMBimport20, MMBimport21, MMBimport22, MMBimport23, MMBimport24, MMBimport25, MMBimport26, MMBimport27, MMBimport28, MMBimport29, MMBimport30 = strsplit("X", MMBimportexportBox:GetText())
    	
--    	for i = 1,30 do print (_G["MMBimport"..i]) end
    	
    	if MMBimport1 ~= select(1,GetAddOnMetadata("MageManaBar", "Version")).."-mage" then
    		print("-- You are importing settings from a different version of MageManaBar, everything should be ok but be ready to reset the addon if problems occurs. --")
    	end
    	
    	MMBTempSettings = {}
    	
    	for i = 2,30 do 
    		
    		if _G["MMBimport"..i] then
				
				local MMBtempImport = ""
				MMBtempImport = "table.insert(MMBTempSettings," .._G["MMBimport"..i]..")"
--				print (MMBtempImport) 
				MMBImportFunction = loadstring(MMBtempImport)
				MMBImportFunction()
			else print("-- Imported new settings in MageManaBar. --")
--				print(i)
				break
			end
	    end
	    
	    MMBSettingsCheck(MMBTempSettings)
	    MMBreset(MMBTempSettings)
        MMBFrameResize()
    
    end
	
end

function MMBTourManager()

	MMBTourFrame:SetFrameStrata("TOOLTIP")
	
	if MMBtourpage == 2 then
		
		MMBTourFrameText1:SetText("With the Arcane Explosion manager you can easily see if you'll be able to keep your Arcane Blast debuff up to AOE at max power.\n\nThe red line showing the cast time of your AB, cross it and you're out of time !")
		MMBTourFrameText1:SetFont("Fonts\\FRIZQT__.TTF",12)
		MMBTourFrameText1:SetJustifyH("LEFT")
		MMBTourFrameImage1:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\AEmanager1")
		MMBTourFrameImage2:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\AEmanager2")
		MMBTourRightButton:SetScript("OnClick",function() MMBtourpage = 3; MMBTourManager() end)
		MMBTourRightButtonText:SetText("Next")
		MMBTourLeftButton:SetScript("OnClick",function() MMBtourpage = 1; MMBTourManager() end)
		MMBTourLeftButtonText:SetText("Previous")
		
	elseif MMBtourpage == 3 then
		
		MMBTourFrameText1:SetText("Getting closer to the UnitFrame replacement with the Casting bar, Alternate power bar and Player menu.\n\nA simple but effective casting bar showing your timer, target and taking in account interrupts and cast delay. Alternate power with percent and name for fast checking. Right click on MageManaBar bring the player menu, left click for player select.")
		MMBTourFrameText1:SetFont("Fonts\\FRIZQT__.TTF",12)
		MMBTourFrameText1:SetJustifyH("LEFT")
		MMBTourFrameImage1:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\Cast1")
		MMBTourFrameImage2:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\Cast2")
		MMBTourRightButton:SetScript("OnClick",function() MMBtourpage = 4; MMBTourManager() end)
		MMBTourRightButtonText:SetText("Next")
		MMBTourLeftButton:SetScript("OnClick",function() MMBtourpage = 2; MMBTourManager() end)
		MMBTourLeftButtonText:SetText("Previous")
		
	elseif MMBtourpage == 4 then
		
		MMBTourFrameText1:SetText("Share and import MageManaBar settings !!\n\nWith so many customisation possibilities, it would be sad to not propose a way to save your settings and share them with your fellow mages. Now you can export/import them with ease. Meet us at the MageManaBar thread on MMO-C forums (link provided on import/export page).")
		MMBTourFrameText1:SetFont("Fonts\\FRIZQT__.TTF",12)
		MMBTourFrameText1:SetJustifyH("LEFT")
		MMBTourFrameImage1:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\Import1")
		MMBTourFrameImage2:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\Import2")
		MMBTourRightButton:SetScript("OnClick",function() MMBTourFrame:Hide() end)
		MMBTourRightButtonText:SetText("Done")
		MMBTourLeftButton:SetScript("OnClick",function() MMBtourpage = 3; MMBTourManager() end)
		MMBTourLeftButtonText:SetText("Previous")
		
	else MMBTourFrameText1:SetText("What's new in MageManaBar ? \n\n Take the tour and discover the wonderful new main features !")
		MMBTourFrameText1:SetFont("Fonts\\FRIZQT__.TTF",16)
		MMBTourFrameText1:SetJustifyH("CENTER")
		MMBTourFrameImage1:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\Greet1")
		MMBTourFrameImage2:SetTexture("Interface\\AddOns\\MageManaBar\\Images\\Greet2")
		MMBTourRightButton:SetScript("OnClick",function() MMBtourpage = 2; MMBTourManager() end)
		MMBTourRightButtonText:SetText("Start Tour")
		MMBTourLeftButton:SetScript("OnClick",function() MMBTourFrame:Hide() end)
		MMBTourLeftButtonText:SetText("No thanks")

	end

end

-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_EVENT FUNCTION ----------------------------------------------------

function MageManaBar_OnEvent(self, event, ...)

	if (event == "PLAYER_LOGIN") then

		MMBNewSettingsCheck()

		MageManaBarWarningBar:SetMinMaxValues(0,2)
		MageManaBarWarningBar2:SetMinMaxValues(0,2)
		MageManaBarCastBar:SetMinMaxValues(0,2)
		MageManaBarAlternateBar:SetMinMaxValues(0,2)

		CreateFrame("Cooldown","MMBevocationCooldown",MMBevocationFrame)
		MMBevocationCooldown:SetAllPoints(MMBevocationFrame)
		MMBevocationCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBevocationgradCooldown",MMBevocationgradFrame)
		MMBevocationgradCooldown:SetAllPoints(MMBevocationgradFrame)
		CreateFrame("Cooldown","MMBmanaGemCooldown",MMBmanaGemFrame)
		MMBmanaGemCooldown:SetAllPoints(MMBmanaGemFrame)
		MMBmanaGemCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBmanaGemgradCooldown",MMBmanaGemgradFrame)
		MMBmanaGemgradCooldown:SetAllPoints(MMBmanaGemgradFrame)
		CreateFrame("Cooldown","MMBmageArmorCooldown",MMBmageArmorFrame)
		MMBmageArmorCooldown:SetAllPoints(MMBmageArmorFrame)
		MMBmageArmorCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBmageArmorgradCooldown",MMBmageArmorgradFrame)
		MMBmageArmorgradCooldown:SetAllPoints(MMBmageArmorgradFrame)
		CreateFrame("Cooldown","MMBArcaneTorrentCooldown",MMBArcaneTorrentFrame)
		MMBArcaneTorrentCooldown:SetAllPoints(MMBArcaneTorrentFrame)
		MMBArcaneTorrentCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBArcaneTorrentgradCooldown",MMBArcaneTorrentgradFrame)
		MMBArcaneTorrentgradCooldown:SetAllPoints(MMBArcaneTorrentgradFrame)
		CreateFrame("Cooldown","MMBOrbCooldown",MMBOrbFrame)
		MMBOrbCooldown:SetAllPoints(MMBOrbFrame)
		MMBOrbCooldown.noCooldownCount = true
		CreateFrame("Cooldown","MMBOrbgradCooldown",MMBOrbgradFrame)
		MMBOrbgradCooldown:SetAllPoints(MMBOrbgradFrame)
		
		if (select(2, UnitRace("player")) ~= "BloodElf") then
			(MMBSettings[11])[2] = false
		end 
		
		if (MMBSettings[1])[20] == false then
			MMBTourFrame:Show()
			MMBTourManager()
		end
		
		MMBFrameResize()

	elseif (event == "UNIT_POWER") then
			
		local unit, powertype = select(1, ...)
	
		if (unit == "player") then
		
            if powertype == "ALTERNATE" then
            
                MMBAltPowerBarUpdate(event)
                
            else MMBmagearmorupdate()
                MMBManabarUpdate()

                if (MMBSettings[15])[2] == true then
                    MMBmanabarcolorchange(event)
                end
                
                if (MMBSettings[1])[17] == true then
                    MMBWastedManaCollect(event)
                end
                
            end
			
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then

			MMBmagearmorupdate()
			MMBManabarUpdate()
	
	elseif (event == "UNIT_MAXPOWER") then
	
		local unit, powertype = select(1, ...)
		
		if (unit == "player") then
		
            if powertype == "ALTERNATE" then
            
                MMBAltPowerBarUpdate(event)
                
            else MMBManabarMaxPool()
                MMBmagearmorupdate()
                if (MMBSettings[1])[17] == true then
                    MMBWastedManaCollect(event)
                end
			end
		end
		
	elseif (event=="COMBAT_LOG_EVENT_UNFILTERED") then

		timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
			
		if (sourceName == UnitName("player")) then
			
			if (event == "SPELL_PERIODIC_ENERGIZE") and (spellId == 6117) or (spellId == 7302) then -- mage armor cooldown
				MMBmageArmorgradCooldown:SetCooldown(0,0)
				MMBmageArmorCooldown:SetCooldown(GetTime(),5)
	
			elseif spellId == 1449 or spellId == 30451 or spellId == 5143 then

				MMBArcaneExplosionWatch (spellId, event)

			end
			
		end
		
		if event == "SPELL_INTERRUPT" and destName == UnitName("player") then
        
            table.wipe(MMBSpellCast)
            MMBCastInterrupt = 1
            MMBCastAlpha = 0
            MageManaBarCastBar:SetValue(1000)
            MageManaBarCastBarTimer:SetText("")
            MageManaBarCastBarText:SetText(format("Interrupted by %s", sourceName or "Unknown"))
            MageManaBarCastBar:SetStatusBarColor(1,0,0,1)
        end

    elseif event == "UNIT_SPELLCAST_STOP" or event == "UNIT_SPELLCAST_CHANNEL_STOP" then

        local unitID, spell, rank, target, lineID = select(1, ...)
        
        if unitID == "player" and MMBCastInterrupt == 0 then

            table.wipe(MMBSpellCast)
            MageManaBarCastBar:SetValue(0)
            MageManaBarCastBarIcon:SetTexture("")
            MageManaBarCastBarText:SetText("")
            MageManaBarCastBarTimer:SetText("")
        end

    elseif event == "UNIT_SPELLCAST_SENT" then
    
        local unitID, spell, rank, target, lineID = select(1, ...)
        
        if unitID == "player" then

            MMBCastInterrupt = 0
            MMBCastTarget = target
            
        end
        
    elseif event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_CHANNEL_START" then

        local unitID, spell, rank, target, lineID = select(1, ...)
        
        if unitID == "player" then
        
            MMBCastInfoStore()
            MMBCastTimeLost = 0
            
        end
        
    elseif event == "UNIT_SPELLCAST_DELAYED" or event == "UNIT_SPELLCAST_CHANNEL_UPDATE" then

        local unitID, spell, rank, target, lineID = select(1, ...)
        
        if unitID == "player" then

            MMBCastInfoStore()
            
            MMBPushback = select(5,GetTalentInfo(2,2))*23
            
            if UnitAura("player", select(1, GetSpellInfo(19746))) then
                
                if MMBPushback > 65 then
                    MMBPushback = 100
                else MMBPushback = MMBPushback + 35
                end
                
            end
            
            if MMBcasttype == "cast" then
                MMBCastTimeLost = MMBCastTimeLost + (0.5 - (0.5*(MMBPushback/100)))
            elseif MMBcasttype == "channel" then
                MMBCastTimeLost = MMBCastTimeLost + ((MMBSpellCast["duration"]/4) - ((MMBSpellCast["duration"]/4)*(MMBPushback/100)))
            end
        end
                		
	elseif (event == "PLAYER_REGEN_DISABLED") or (event == "PLAYER_REGEN_ENABLED") or (event == "PLAYER_TALENT_UPDATE") then
        
        MMBArcaneExplosionHide ()
		MMBAutohide()
		MMBmageArmorSpec()
		MMBAEcount = 0
		MMBABcount = 2
		
	elseif (event == "UNIT_HEALTH") or (event == "UNIT_MAXHEALTH") then
	
		local unit = select(1, ...)
		
		if unit == "player" then
			MMBhealthUpdate()
		end
	
    elseif event == "UNIT_POWER_BAR_SHOW" then
    
        MageManaBarAlternate:Show()
        MMBAutohideManager("MageManaBarAlternate","show")
        MMBAltPowerBarUpdate("UNIT_MAXPOWER")
        MMBAltPowerBarUpdate("UNIT_POWER")
        
    elseif event == "UNIT_POWER_BAR_HIDE" and (MMBSettings[22])[10] == true then
    
    	MageManaBarAlternateText:SetText("")
    	MageManaBarAlternateBar:SetValue(0)
        MageManaBarAlternate:Hide()
        MMBAutohideManager("MageManaBarAlternate","hide")
    
	end
	
	if (event == "PLAYER_REGEN_ENABLED") then
	
		if MMBTotalWastedMana ~= 0 and (MMBSettings[1])[17] == true then
			print(format("|cffff00ff -- You wasted |cffffffff%s |cffff00ffmana during this fight --", MMBNumberConvert(MMBTotalWastedMana)))
		end
		MMBTotalWastedMana = 0
		MMBAEcount = 0
		MMBABcount = 0
		
    elseif (event == "PLAYER_REGEN_DISABLED") then
		MMBTotalWastedMana = 0
	end
end

-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------

function MageManaBar_OnUpdate(self, elapsed)

    MMBCastBarUpdate()

	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	self.TimeSinceLastUpdate1sec = (self.TimeSinceLastUpdate1sec or 0) + elapsed;
	
		if (self.TimeSinceLastUpdate > MageManaBar_UpdateInterval) then
		
			MMBmanaInfoUpdate()
			MMBwarning()
			
			if (MMBSettings[21])[2] == true then -- cast bar interrupt manager
			
				if MMBCastInterrupt == 1 and MMBCastAlpha <= 1 then
				   
					MMBCastAlpha = MMBCastAlpha + 0.2
					MageManaBarCastBar:SetAlpha(1-MMBCastAlpha)

				elseif MMBCastInterrupt == 1 and MMBCastAlpha <= 0 then 
			--	print("prut")
					MMBCastInterrupt = 0
					MageManaBarCastBar:SetValue(0)
					MageManaBarCastBarIcon:SetTexture("")
					MageManaBarCastBarText:SetText("")
					MageManaBarCastBarTimer:SetText("")
					MageManaBarCastBar:SetAlpha(1)
				
				end
			end
            
			if ((MMBSettings[14])[2] == true) then -- current cast mana cost manager
				MMBSpellcastManaCost()
			end
			
			if (MMBInfoCoordsTarget ~= nil) then
				MMBInfoCoords(_G[MMBInfoCoordsTarget[1]],MMBInfoCoordsTarget[2])
			end
			
            if ((MMBSettings[8])[2] == true) then MMBSpellTimer("evocation",12051) end
			if ((MMBSettings[9])[2] == true) then MMBSpellTimer("manaGem",5405) end
			if ((MMBSettings[11])[2] == true) then MMBSpellTimer("ArcaneTorrent",28730) end
			if ((MMBSettings[12])[2] == true) then MMBSpellTimer("Orb",82731) end
						
			self.TimeSinceLastUpdate = 0
			
		end

		if (self.TimeSinceLastUpdate1sec > MageManaBar1sec_UpdateInterval) then
							
			------------------------------------- Mage Armor stuff
			MMBMageArmorType()
			
			self.TimeSinceLastUpdate1sec = 0
		
		end
end


SLASH_MMBCONFIG1 = "/magemanabar"

SlashCmdList["MMBCONFIG"] = function(msg)

	if msg == "" or  msg == "help" or  msg == "?" or msg == "config" then
		 InterfaceOptionsFrame_OpenToCategory("MageManaBar")
	else
		 InterfaceOptionsFrame_OpenToCategory("MageManaBar")
	end

end
